function Extracted = extract_seq_by_cordinates(S,C)
% Extracted = extract_seq_by_cordinates(S,C);
% 
% S = long seq from which subseq is to be extracted
% C = the S indices to extract from
%   C is always in pairs, each pair corresponds to an exon
%   Ascending C indicates a + DNA, descending indicates - DNA

num_of_exons = length(C) / 2;
Exons = cell(1,num_of_exons);
k = 1;
for j = 1: 2: (num_of_exons * 2)
    Exons{k} = S( C(j) : C(j+1) );
    if isempty(Exons{k})
        Exons{k} = seqrcomplement( S( C(j+1) : C(j) ) );
    end
    k = k + 1;
end
Extracted = strjoin(Exons,'');

end