function [fold_16S] = Extract_16S_fold()
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% this function calculates the fold energy of thr 16S of every chloroplast,
% and 'multi_16S' which is a vector that consists all the chloroplasts
% number that their 16S has more than one sequence.
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

load('number_chloro.mat')
load('Seq_16S.mat')

fold_16S = zeros(len(Seq_16S),len(20:45));
multi_16S = [];
s16_count = 0;
for c = 1:number_chloro
    for am_nt_16S=20:45
        s16_count = s16_count + 1;
        % if there are more then one sequence of 16S calculate the average % energy
        cur_energy_mat = [];
        for num_seq = 1:length(Seq_16S{c})
            if length(Seq_16S{c})>1
                multi_16S = [multi_16S;c];
            end
            cur_energy_mat = [cur_energy_vec;mRNA_fold(Seq_16S{c}{num_seq},am_nt_16S)];
        end
        cur_energy_vec = mean(cur_energy_mat);
        fold_16S(c,:) = cur_energy_vec;
    end
end
save('fold_16S','fold_16S')
save('multi_16S','multi_16S')
end

