function [] = Extract_Features_cofold(c)
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% this function extracts all the cofold energy features for chloroplasts number c, 
% cofold_energy_mat - amount genes X 50 (positions before ATG) matrix, every
% column is a position according to the ATG in which a window strats for the mRNA fold
% energy calculation, every row is for a different gene.

% 1820 (but only 14*26 matrix) features- fold energy of mRNA in positions -50:-1 for mRNA length= 25:5:90 (put Nan if no nt in the 5'UTR)
% 2 * 14 *26 = 728 more- take the min out of 50 positions, or min out of 20 positions
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

%% load veriables
load(sprintf('chloro%s.mat',c))
load('Seq_16S.mat')
load('fold_16S.mat') 
load('T_F_mat.mat') 
load('multi_16S.mat') 


%% parameters and data
genes=chloro.genes_energy;

%% Feature calculations:

% cofold
chloro_ind = T_F_mat{c};
mRNA_count = 0;
for mRNA_l = 25:5:90
    mRNA_count = mRNA_count + 1;
    ind_for_energy = chloro_ind{mRNA_count};
    count_16S=0;
    cofold_cell=cell(length(20:45),1);
    for S16_l=20:45
        count_16S=count_16S+1;

        %extracting fold energy of this cloro's 16S
        fold_16S_cur=fold_16S{c,S16_l-20+1};
        [cofold_energy_mat] = cofold(genes,mRNA_l,S16_l,c,multi_16S,Seq_16S);
        cofold_energy_mat(ind_for_energy==0)=nan;

        cofold_cell{count_16S}=cofold_energy_mat;
    end
    save(sprintf('c%d_cofold%d',c,mRNA_l),'cofold_cell');
    
end

end
