function [] = Extract_Features_fold(c)
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% this function extracts all the fold energy features for chloroplasts
% number c
% fold_energy_mat - amount genes X 50 (positions before ATG) matrix, every
% column is a position according to the ATG in which a window strats for the mRNA fold
% energy calculation, every row is for a different gene.

% 700 (but only 14 matrix) features- fold energy of mRNA in positions -50:-1 for mRNA length= 25:5:90 (put Nan if no nt in the 5'UTR)
% 2 * 14 = 28 more- take the min out of 50 positions, or min out of 20 positions
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

%% load veriables
load(sprintf('chloro%d.mat',c));
load('Seq_16S.mat');
load('T_F_mat.mat') 

%% parameters and data
genes=chloro.genes_energy;

%% Feature calculations:
chloro_ind = T_F_mat{c};
% mRNA fold 
mRNA_count = 0;
for mRNA_l = 25:5:90
    mRNA_count = mRNA_count + 1;
    ind_for_energy = chloro_ind{mRNA_count};
    [fold_energy_mat] = mRNA_fold(genes,mRNA_l);   
    fold_energy_mat(ind_for_energy==0)=nan;
    save(sprintf('c%d_mRNA_fold%d',c,mRNA_l),'fold_energy_mat');
end

end

