function add_features_to_group(gr)

load('number_chloro.mat');
load(sprintf('group%d.mat',gr));

fold = cell(height(group),1);
co_fold = cell(height(group),1);

for gene = 1:height(group)
    c = group.C(gene);
    gene_ind = group.g(gene);
    cur_fold = cell(length(25:5:90),1);
    cur_cofold = cell(length(25:5:90),1);
    mrna_count = 0;
    for mRNA_l = 25:5:90 
        mrna_count = mrna_count + 1;
        load(sprintf('c%d_mRNA_fold%d.mat',c,mRNA_l));
        cur_fold{mrna_count} = fold_energy_mat(gene_ind,:);

        s16_cofold = cell(length(20:45),1);
        s16_minusfold = cell(length(20:45),1);
        s16_count = 0;
        for s16 = 20:45
            s16_count = s16_count + 1;

            load(sprintf('c%d_cofold%d.mat',c,mRNA_l));
            s16_cofold{s16_count} = cofold_cell{s16_count}(group.g(gene),:);
        end
        cur_cofold{mrna_count}=s16_cofold;
    end

    fold{gene,1}=cur_fold;
    co_fold{gene,1}=cur_cofold;

end

group.Fold=fold;
group.CoFold=co_fold; 

group_fold = group(:,[1:4,10:12]); 
group_cofold = group(:,[1:4,10,11,13]); 
save(sprintf('gr_feat%d_fold.mat',gr),'group_fold');
save(sprintf('gr_feat%d_cofold.mat',gr),'group_cofold');
save(sprintf('group%d.mat',gr),'group');

%% save small group features

mRNA_count = 0;
for mRNA = 25:5:90
    mRNA_count = mRNA_count + 1;
    s16_count = 0;
    cofold = cell(height(group_cofold),1);
    for s16 = 20:45
        s16_count = s16_count + 1;  
        for g = 1:height(group_cofold)
            cofold{g} = group_cofold.CoFold{g}{mRNA_count}{s16_count};
        end
        group_cofold_new = group_cofold;
        group_cofold_new.CoFold = cofold;
        save(sprintf('gr%d_cofold_%d_%d.mat',gr,mRNA,s16),'group_cofold_new')
    end
end

mRNA_count = 0;
for mRNA = 25:5:90
    mRNA_count = mRNA_count + 1;
    fold = cell(height(group_fold),1);
    for g = 1:height(group_fold)
        fold{g} = group_fold.Fold{g}{mRNA_count};
    end
    group_fold_new = group_fold;
    group_fold_new.CoFold = fold;
    save(sprintf('gr%d_fold_%d.mat',gr,mRNA),'group_fold_new')
end


end
