function cofold_mat = cofold(genes,mRNA_l,S16_l,c,multi_16S,Seq_16S)
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Calculates the cofold energy of all the genes mRNA,
% window length = mRNA_l, 16S length = S16_l
% in all positions -50:-1
% if there are multi 16S seq, it calculates cofold for all 16S, and takes
% the mean energy values
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

% parameters 
am_genes=length(genes);
pos=50;

if isempty(find(multi_16S==c)) %it meant there is only one 16S seq for this chloro
    is_multi=0;
    repeat=1;
else
    is_multi=1;
    repeat=length(Seq_16S{c});
end

cofold_sum=zeros(am_genes,pos);
for r = 1:repeat
    cofold_energy = cofold_mat_calc(mRNA_l,S16_l,genes,Seq_16S{c},r,pos);    
    cofold_sum=cofold_sum+cofold_energy;
end
cofold_mat=cofold_sum./r;

end