%% group ind for train and test
load('number_groups.mat')
group_ind_train = cell(number_groups,1);
group_ind_test = cell(number_groups,1);

vectorized_Zscored_CAI_train = zeros(1,50);
vectorized_Zscored_CAI_test = zeros(1,50);
for gr = 1:number_groups
    load(sprintf('group%d.mat',gr))
    num_genes = 1:height(group);
    rand_genes_ind = num_genes(randperm(length(num_genes)));
    train_genes = rand_genes_ind(1:round(num_genes/2));
    test_genes = rand_genes_ind(round(num_genes/2)+1:end);
    
    vectorized_Zscored_CAI_train = [vectorized_Zscored_CAI_train;group.CAI_Zscore(train_genes)];
    vectorized_Zscored_CAI_test = [vectorized_Zscored_CAI_test;group.CAI_Zscore(test_genes)];
    
    group_ind_train{gr} = train_genes;
    group_ind_test{gr} = test_genes;
end
save('vectorized_Zscored_CAI_train','vectorized_Zscored_CAI_train')
save('vectorized_Zscored_CAI_test','vectorized_Zscored_CAI_test')
save('group_ind_train','group_ind_train')
save('group_ind_test','group_ind_test')

for rand = 1:50
    vectorized_Zscored_CAI_train_rand = [];
    vectorized_Zscored_CAI_test_rand = [];
    for gr = 1:number_groups
        load(sprintf('group%d.mat',gr))
        vectorized_Zscored_CAI_train_rand = [vectorized_Zscored_CAI_train_rand;group.CAI_Zscore_rand(train_genes,rand)];
        vectorized_Zscored_CAI_test_rand = [vectorized_Zscored_CAI_test_rand;group.CAI_Zscore_rand(test_genes,rand)];
    end
    save(sprintf('vectorized_Zscored_CAI_rand_train%d',rand),'vectorized_Zscored_CAI_rand_train')
save(sprintf('vectorized_Zscored_CAI_test_rand%d',rand),'vectorized_Zscored_CAI_test_rand')
end
%% total genes in test and train
am_genes_train = 0;
am_genes_test = 0;

for i= 1:number_groups
    am_genes_train = am_genes_train + length(group_ind_train{i});
    am_genes_test = am_genes_test + length(group_ind_test{i});
end

%% right places
right_places_train = cell(number_groups,1);
right_places_test = cell(number_groups,1);

count = 0;
for gr = 1:number_groups
    for gene = 1:length(group_ind_train{gr})
        count=count+1;
        right_places_train{gr}(gene)=count;
    end
end


count = 0;
for gr = 1:number_groups
    for gene = 1:length(group_ind_test{gr})
        count=count+1;
        right_places_test{gr}(gene)=count;
    end
end

save('right_places_train','right_places_train')
save('right_places_test','right_places_test')


% create chloro num vec for vectorized energy 
load('right_places_train.mat'); 
load('right_places_test.mat'); 
train_c_for_g = zeros(am_genes_train,1);
test_c_for_g = zeros(am_genes_test,1);
for gr = 1:number_groups
    load(sprintf('gr_feat%d_fold.mat',gr));
    for g = 1:length(group_ind_train{gr_i})
        gene = group_ind_train{gr_i}(g);
        train_c_for_g(right_places_train{gr_i}(g)) = group_fold.C(gene);
    end
    % test:
    for g = 1:length(group_ind_test{gr_i})
        gene = group_ind_test{gr_i}(g);
        test_c_for_g(right_places_test{gr_i}(g)) = group_fold.C(gene);
    end
end
save('train_c_for_g.mat','train_c_for_g')
save('test_c_for_g.mat','test_c_for_g')