% chlami data
chlami_gr = [];
chlami_genes_no = [];
chlami_genes = {};
chlami_chloro_num = 0;
count = 0;
for gr = 1:number_groups
    load(sprintf('group%d.mat',gr))
    for gene = 1:height(group)
        if strcmp(group.Chloro{gene},'chloroplast Chlamydomonas reinhardtii')
            if chlami_chloro_num == 0
                chlami_chloro_num = group.C{gene};
            end
            count = count + 1;
            chlami_gr(count) = gr;
            chlami_genes_no(count) = gene;
            chlami_genes{count} = group.Gene_name{gene};
        end
    end
end

save('chlami_genes','chlami_genes')
save('chlami_genes_no','chlami_genes_no')
save('chlami_gr','chlami_gr')
save('chlami_chloro_num','chlami_chloro_num')

% create CAI vec for Chlami
load(sprintf('chloro%d.mat',chlami_chloro_num))
chlami_CAI = zeros(length(chlami_genes),1);
chlami_Zscored_CAI = zeros(length(chlami_genes),1);
for g = 1:length(chlami_genes)
    genes_idx = find(strcmp(chlami_genes{g},chloro.genes_name));
    if length(genes_idx) >= 1
        chlami_CAI(g) = chloro.CAI(genes_idx(1));
        chlami_Zscored_CAI(g) = chloro.CAI_Zscore(genes_idx(1));
    end
end
save('chlami_CAI','chlami_CAI')
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ %
%% every genome corrs, save chlami energies
load('chloro_names.mat')
load('number_groups.mat')
load('best_start_fold.mat')
load('best_constrains_fold.mat')
load('best_start_cofold.mat')
load('best_constrains_cofold.mat')
load('best_start_ETIP.mat')
load('best_constrains_ETIP.mat')
c_corrs = zeros(length(chloro_names,3));
am_genes_c = zeros(length(chloro_names),1);
for c = 1:length(chloro_names)
    c_gr = [];
    c_genes_no = [];
    c_genes = {};
    count = 0;
    for gr = 1:number_groups
        load(sprintf('group%d.mat',gr))
        for gene = 1:height(group)
            if strcmp(group.Chloro{gene},chloro_names{c})
                count = count + 1;
                c_gr(count) = gr;
                c_genes_no(count) = gene;
                c_genes{count} = group.Gene_name{gene};
            end
        end
    end
    c_fold_energy = zeros(count,1);
    c_cofold_energy = zeros(count,1);
    c_ETIP_energy = zeros(count,1);
    c_Zscored_CAI = zeros(count,1);
    am_genes_c(c) = count;
    for g = 1:count
        gr = c_gr(g);
        gene = c_genes_no(g);
        load(sprintf('res_fold_start%d_%d.mat',best_start_fold,best_constrains_fold))
        load(sprintf('gr%d_fold_%d.mat',gr,params{gr}(1)))  
        % best fold params 
        c_fold_energy(g) = group_fold_new.Fold{gene}(params{gr}(2));
        c_Zscored_CAI(g) = group_fold_new.CAI_Zscore(gene);

        load(sprintf('res_cofold_startt%d_%d.mat',best_start_cofold,best_constrains_cofold))
        load(sprintf('gr%d_cofold_%d_%d.mat',gr,params{gr}(1),params{gr}(2)))  
        % best cofold params 
        c_cofold_energy(g) = group_cofold_new.CoFold{gene}(params{gr}(3));

        load(sprintf('res_ETIP_start%d_%d.mat',best_start_ETIP,best_constrains_ETIP)) %%
        load(sprintf('gr%d_ETIP_%d_%d.mat',gr,params{gr_i}(1),params{gr_i}(2)))  
        % best ETIP params 
        c_ETIP_energy(g) = group_ETIP_new.MinusFold{gene}(params{gr_i}(3));
    end
    if c == chlami_chloro_num
        chlami_fold_energy = c_fold_energy;
        chlami_Zscored_CAI = c_Zscored_CAI;
        chlami_cofold_energy = c_cofold_energy;
        chlami_ETIP_energy = c_ETIP_energy;
        save('chlami_fold_energy','chlami_fold_energy')
        save('chlami_Zscored_CAI','chlami_Zscored_CAI')
        save('chlami_cofold_energy','chlami_cofold_energy')
        save('chlami_ETIP_energy','chlami_ETIP_energy')
    end
    % take out nans and calculate correlation
    c_fold_energy_non = c_fold_energy(~isnan(c_fold_energy));
    c_Zscored_CAI_non = c_Zscored_CAI(~isnan(c_fold_energy));
    [r,~] = corr(c_Zscored_CAI_non,c_fold_energy_non,'Type','Spearman');
    c_corrs(c,1) = r;
    
    c_cofold_energy_non = c_fold_energy(~isnan(c_cofold_energy));
    c_Zscored_CAI_non = c_Zscored_CAI(~isnan(c_cofold_energy));
    [r,~] = corr(c_Zscored_CAI_non,c_cofold_energy_non,'Type','Spearman');
    c_corrs(c,2) = r;
    
    c_ETIP_energy_non = c_ETIP_energy(~isnan(c_ETIP_energy));
    c_Zscored_CAI_non = c_Zscored_CAI(~isnan(c_ETIP_energy));
    [r,~] = corr(c_Zscored_CAI_non,c_ETIP_energy_non,'Type','Spearman');
    c_corrs(c,3) = r;
end
save('c_corrs.mat','c_corrs')
save('am_genes_c.mat','am_genes_c')

% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ %
load('chlami_PA1.mat') 
load('chlami_PA2.mat')
[numbers, strings, raw] = xlsread('Chlami_ribo_summery.xlsx');
genes_from_file = strings(4:end,1);
chlami_mean_PA = mean([chlami_PA1,chlami_PA2],2);
save('chlami_mean_PA','chlami_mean_PA')
chlami_data = table(chlami_genes',chlami_gr',chlami_fold_energy,chlami_cofold_energy,chlami_ETIP_energy,chlami_Zscored_CAI,chlami_CAI,chlami_mean_PA);
chlami_data.Properties.VariableNames = {'chlami_genes' 'chlami_gr' 'chlami_fold_energy' 'chlami_cofold_energy' 'chlami_ETIP_energy' 'chlami_Zscored_CAI' 'chlami_CAI' 'chlami_mean_PA', 'chlami_Ribo_seq'};
chlami_ribo_seq = zeros(height(chlami_data),1);
for chlami_gene = 1:height(chlami_data)
    for gene = 1:length(genes_from_file)
        if strcmp(chlami_data.Var1{chlami_gene},genes_from_file{gene})
           chlami_ribo_seq(chlami_gene) = raw{gene+3,27};
        end
    end
end
chlami_data.Ribo_seq = chlami_ribo_seq;
save('chlami_data','chlami_data')

%% regressor with PA
% arrange ranked vectors and no nans vector
no_nans_ETIP = chlami_ETIP_energy(~isnan(chlami_data.chlami_mean_PA)&~isnan(chlami_ETIP_energy));
non_nans_PA = chlami_data.chlami_mean_PA(~isnan(chlami_data.chlami_mean_PA)&~isnan(chlami_ETIP_energy));
no_nans_CAI = chlami_data.chlami_CAI(~isnan(chlami_data.chlami_mean_PA));

% sort and rank CAI and PA
[~,idx_sort]=sort(no_nans_CAI);
rank_CAI = zeros(length(no_nans_CAI),1);
rank_CAI(idx_sort) = 1:length(no_nans_CAI);
[~,idx_sort]=sort(non_nans_PA);
rank_PA = zeros(length(non_nans_PA),1);
rank_PA(idx_sort) = 1:length(non_nans_PA);
[~,idx_sort]=sort(no_nans_ETIP);
rank_ETIP = zeros(length(no_nans_ETIP),1);
rank_ETIP(idx_sort) = 1:length(no_nans_ETIP);
save('rank_CAI_PA','rank_CAI')
save('rank_PA','rank_PA')
save('rank_ETIP_PA','rank_ETIP')

% create regressors and calculate corrs
corrs_regression = zeros(4,4); % rows are: 1.regress spearman, 2. regress preason 3.lasso spearman, 4. lasso preason
pv_regression = zeros(4,4);
y_all = zeros(length(non_nans_PA),2);
y_hat_all = zeros(length(non_nans_PA),4);
y_hat2_all = zeros(length(non_nans_PA),4);
bint_all = zeros(2,1);
% only CAI

% regress with CAI, Spearman and Pearson
y = non_nans_PA;
X = [ones(length(y),1),no_nans_CAI];
[b,~] = regress(y,X);
y_hat = b(1)*X(:,1)+b(2)*X(:,2);
y_hat_all(:,1)=y_hat;

[r,pv] = corr(y,y_hat,'Type','Spearman');
corrs_regression(1,1) = r;
pv_regression(1,1) = pv;

[r,pv] = corr(y,y_hat,'Type','Pearson');
corrs_regression(2,1) = r;
pv_regression(2,1) = pv;

% lasso with CAI, Spearman and Pearson
[b2,FitInfo] = lasso(X,y,'Alpha',0.75,'CV',10);
idxLambda1SE = FitInfo.Index1SE;
coef = b2(:,idxLambda1SE);
y_hat2 = coef(1)*X(:,1)+coef(2)*X(:,2);
y_hat2_all(:,1)=y_hat2;

[r,pv] = corr(y,y_hat2,'Type','Spearman');
corrs_regression(3,1) = r;
pv_regression(3,1) = pv;

[r,pv] = corr(y,y_hat2,'Type','Pearson');
corrs_regression(4,1) = r;
pv_regression(4,1) = pv;


%regress with ranked CAI, Spearman and Pearson
y = rank_PA;
y_all(:,2)=y;
X = [ones(length(y),1),rank_CAI];
[b,bint] = regress(y,X);
y_hat = X*b;
y_hat_all(:,2)=y_hat;

[r,pv] = corr(y,y_hat,'Type','Spearman');
corrs_regression(1,2) = r;
pv_regression(1,2) = pv;

[r,pv] = corr(y,y_hat,'Type','Pearson');
corrs_regression(2,2) = r;
pv_regression(2,2) = pv;

% lasso with ranked CAI, Spearman and Pearson
[b2,FitInfo] = lasso(X,y,'Alpha',0.75,'CV',10);
idxLambda1SE = FitInfo.Index1SE;
coef = b2(:,idxLambda1SE);
y_hat2 = coef(1)*X(:,1)+coef(2)*X(:,2);
y_hat2_all(:,2)=y_hat2;

[r,pv] = corr(y,y_hat2,'Type','Spearman');
corrs_regression(3,2) = r;
pv_regression(3,2) = pv;

[r,pv] = corr(y,y_hat2,'Type','Pearson');
corrs_regression(4,2) = r;
pv_regression(4,2) = pv;

% CAI and ETIP

% regress with CAI and ETIP, Spearman and Pearson
y = non_nans_PA;
X = [ones(length(y),1),no_nans_CAI,no_nans_ETIP];
[b,bint] = regress(y,X);
bint_all(1) = sign(bint(3,1))~=sign(bint(3,2));
y_hat = b(1)*X(:,1)+b(2)*X(:,2)+b(3)*X(:,3);
y_hat_all(:,3)=y_hat;

[r,pv] = corr(y,y_hat,'Type','Spearman');
corrs_regression(1,3) = r;
pv_regression(1,3) = pv;

[r,pv] = corr(y,y_hat,'Type','Pearson');
corrs_regression(2,3) = r;
pv_regression(2,3) = pv;

% lasso with CAI and ETIP, Spearman and Pearson
[b2,FitInfo] = lasso(X,y,'Alpha',0.75,'CV',10);
idxLambda1SE = FitInfo.Index1SE;
coef = b2(:,idxLambda1SE);
y_hat2 = coef(1)*X(:,1)+coef(2)*X(:,2)+coef(3)*X(:,3);
y_hat2_all(:,3)=y_hat2;

[r,pv] = corr(y,y_hat2,'Type','Spearman');
corrs_regression(3,3) = r;
pv_regression(3,3) = pv;

[r,pv] = corr(y,y_hat2,'Type','Pearson');
corrs_regression(4,3) = r;
pv_regression(4,3) = pv;

%regress with ranked CAI and ranked ETIP, Spearman and Pearson
y = rank_PA;
X = [ones(length(y),1),rank_CAI,rank_ETIP];
[b,bint] = regress(y,X);
bint_all(2) = sign(bint(3,1))~=sign(bint(3,2));
y_hat = X*b;
y_hat_all(:,4)=y_hat;

[r,pv] = corr(y,y_hat,'Type','Spearman');
corrs_regression(1,4) = r;
pv_regression(1,4) = pv;

[r,pv] = corr(y,y_hat,'Type','Pearson');
corrs_regression(2,4) = r;
pv_regression(2,4) = pv;

% lasso with ranked CAI and ranked ETIP, Spearman and Pearson
[b2,FitInfo] = lasso(X,y,'Alpha',0.75,'CV',10);
idxLambda1SE = FitInfo.Index1SE;
coef = b2(:,idxLambda1SE);
y_hat2 = coef(1)*X(:,1)+coef(2)*X(:,2)+coef(3)*X(:,3);
y_hat2_all(:,4)=y_hat2;

[r,pv] = corr(y,y_hat2,'Type','Spearman');
corrs_regression(3,4) = r;
pv_regression(3,4) = pv;

[r,pv] = corr(y,y_hat2,'Type','Pearson');
corrs_regression(4,4) = r;
pv_regression(4,4) = pv;

% save 
save('corrs_regression_PA','corrs_regression')
save('pv_regression_PA','pv_regression')
save('y_all_PA','y_all')
save('y_hat_all_PA','y_hat_all')
save('y_hat2_all_PA','y_hat2_all')
save('bint_all_PA','bint_all')

% calculate partial correlation
[rho, pv] = partialcorr([non_nans_PA,no_nans_ETIP], no_nans_CAI ,'Type','Spearman');
partialcorr_regressor_chlami = [rho(1,2),pv(1,2)];
save('partialcorr_regressor_chlami_PA','partialcorr_regressor_chlami')


%% regressor with ribo-seq
% load ribo-seq
chlami_ribo_seq = cell(height(chlami_data),1);
for sheet = 1:5
    [numbers, strings, raw] = xlsread('tpc111567SD1.xls' ,sheet);
    riboseq_from_file = numbers(:,19);
    genes_from_file = strings(6:length(riboseq_from_file)+6-1,1);
    for chlami_gene = 1:height(chlami_data)
        for probe = 1:length(genes_from_file)
            genes_probe = split(genes_from_file{probe},'-');
            all_genes_row = {};
            for g = 1:length(genes_probe)
                gene_file = split(genes_probe{g},'_');
                all_genes_row = [all_genes_row;gene_file];
            end
            for gene_file = 1:length(all_genes_row)
                if strcmp(chlami_data.Var1{chlami_gene},all_genes_row{gene_file})
                   chlami_ribo_seq{chlami_gene} = [chlami_ribo_seq{chlami_gene};riboseq_from_file(probe)];
                end
            end
        end
    end
end
chlami_ribo_seq_mean = zeros(length(chlami_ribo_seq),1);
for chlami_g = 1:length(chlami_ribo_seq)
    chlami_ribo_seq_mean(chlami_g) = nanmean(chlami_ribo_seq{chlami_g});
end
chlami_data.Ribo_seq = chlami_ribo_seq_mean;
save('chlami_data','chlami_data')

no_nans_ETIP = chlami_data.chlami_minusfold_energy(~isnan(chlami_data.Ribo_seq)&~isnan(chlami_data.chlami_minusfold_energy));
non_nans_riboseq = chlami_data.Ribo_seq(~isnan(chlami_data.Ribo_seq)&~isnan(chlami_data.chlami_minusfold_energy));
no_nans_CAI = chlami_data.chlami_CAI(~isnan(chlami_data.Ribo_seq));

% sort and rank CAI and PA
[~,idx_sort]=sort(no_nans_CAI);
rank_CAI = zeros(length(no_nans_CAI),1);
rank_CAI(idx_sort) = 1:length(no_nans_CAI);
[sorted,idx_sort]=sort(non_nans_riboseq);
rank_ribo_seq = zeros(length(non_nans_riboseq),1);
rank_ribo_seq(idx_sort) = 1:length(non_nans_riboseq);
[~,idx_sort]=sort(no_nans_ETIP);
rank_ETIP = zeros(length(no_nans_ETIP),1);
rank_ETIP(idx_sort) = 1:length(no_nans_ETIP);
save('rank_CAI_ribo_seq','rank_CAI')
save('rank_ribo_seq','rank_ribo_seq')
save('rank_ETIP_ribo_seq','rank_ETIP')

% create regressors and calculate corrs
corrs_regression = zeros(4,4); % rows are: 1.regress spearman, 2. regress preason 3.lasso spearman, 4. lasso preason
% clolumns : 1. CAI, 2. ranked CAI, 3. CAI + energy, 4.ranged CAI + energy
pv_regression = zeros(4,4);
y_all = zeros(length(non_nans_riboseq),2);
y_hat_all = zeros(length(non_nans_riboseq),4);
y_hat2_all = zeros(length(non_nans_riboseq),4);
bint_all = zeros(2,1);
% only CAI

% regress with CAI, Spearman and Pearson
y = non_nans_riboseq;
y_all(:,1)=y;
X = [ones(length(y),1),no_nans_CAI];
[b,~] = regress(y,X);
y_hat = b(1)*X(:,1)+b(2)*X(:,2);
y_hat_all(:,1)=y_hat;

[r,pv] = corr(y,y_hat,'Type','Spearman');
corrs_regression(1,1) = r;
pv_regression(1,1) = pv;

[r,pv] = corr(y,y_hat,'Type','Pearson');
corrs_regression(2,1) = r;
pv_regression(2,1) = pv;

% lasso with CAI, Spearman and Pearson
[b2,FitInfo] = lasso(X,y,'Alpha',0.75,'CV',10);
idxLambda1SE = FitInfo.Index1SE;
coef = b2(:,idxLambda1SE);
y_hat2 = coef(1)*X(:,1)+coef(2)*X(:,2);
y_hat2_all(:,1)=y_hat2;

[r,pv] = corr(y,y_hat2,'Type','Spearman');
corrs_regression(3,1) = r;
pv_regression(3,1) = pv;

[r,pv] = corr(y,y_hat2,'Type','Pearson');
corrs_regression(4,1) = r;
pv_regression(4,1) = pv;


%regress with ranked CAI, Spearman and Pearson
y = rank_ribo_seq;
y_all(:,2)=y;
X = [ones(length(y),1),rank_CAI];
[b,bint] = regress(y,X);
y_hat = X*b;
y_hat_all(:,2)=y_hat;

[r,pv] = corr(y,y_hat,'Type','Spearman');
corrs_regression(1,2) = r;
pv_regression(1,2) = pv;

[r,pv] = corr(y,y_hat,'Type','Pearson');
corrs_regression(2,2) = r;
pv_regression(2,2) = pv;

% lasso with ranked CAI, Spearman and Pearson
[b2,FitInfo] = lasso(X,y,'Alpha',0.75,'CV',10);
idxLambda1SE = FitInfo.Index1SE;
coef = b2(:,idxLambda1SE);
y_hat2 = coef(1)*X(:,1)+coef(2)*X(:,2);
y_hat2_all(:,2)=y_hat2;

[r,pv] = corr(y,y_hat2,'Type','Spearman');
corrs_regression(3,2) = r;
pv_regression(3,2) = pv;

[r,pv] = corr(y,y_hat2,'Type','Pearson');
corrs_regression(4,2) = r;
pv_regression(4,2) = pv;

% CAI and ETIP

% regress with CAI and ETIP, Spearman and Pearson
y = non_nans_riboseq;
X = [ones(length(y),1),no_nans_CAI,no_nans_ETIP];
[b,bint] = regress(y,X);
bint_all(1) = sign(bint(3,1))~=sign(bint(3,2))
y_hat = b(1)*X(:,1)+b(2)*X(:,2)+b(3)*X(:,3);
y_hat_all(:,3)=y_hat;

[r,pv] = corr(y,y_hat,'Type','Spearman');
corrs_regression(1,3) = r;
pv_regression(1,3) = pv;

[r,pv] = corr(y,y_hat,'Type','Pearson');
corrs_regression(2,3) = r;
pv_regression(2,3) = pv;

% lasso with CAI and ETIP, Spearman and Pearson
[b2,FitInfo] = lasso(X,y,'Alpha',0.75,'CV',10);
idxLambda1SE = FitInfo.Index1SE;
coef = b2(:,idxLambda1SE);
y_hat2 = coef(1)*X(:,1)+coef(2)*X(:,2)+coef(3)*X(:,3);
y_hat2_all(:,3)=y_hat2;

[r,pv] = corr(y,y_hat2,'Type','Spearman');
corrs_regression(3,3) = r;
pv_regression(3,3) = pv;

[r,pv] = corr(y,y_hat2,'Type','Pearson');
corrs_regression(4,3) = r;
pv_regression(4,3) = pv;

%regress with ranked CAI and ranked ETIP, Spearman and Pearson
y = rank_ribo_seq;
X = [ones(length(y),1),rank_CAI,rank_ETIP];
[b,bint] = regress(y,X);
bint_all(2) = sign(bint(3,1))~=sign(bint(3,2))
y_hat = X*b;
y_hat_all(:,4)=y_hat;

[r,pv] = corr(y,y_hat,'Type','Spearman');
corrs_regression(1,4) = r;
pv_regression(1,4) = pv;

[r,pv] = corr(y,y_hat,'Type','Pearson');
corrs_regression(2,4) = r;
pv_regression(2,4) = pv;

% lasso with ranked CAI and ranked ETIP, Spearman and Pearson
[b2,FitInfo] = lasso(X,y,'Alpha',0.75,'CV',10);
idxLambda1SE = FitInfo.Index1SE;
coef = b2(:,idxLambda1SE);
y_hat2 = coef(1)*X(:,1)+coef(2)*X(:,2)+coef(3)*X(:,3);
y_hat2_all(:,4)=y_hat2;

[r,pv] = corr(y,y_hat2,'Type','Spearman');
corrs_regression(3,4) = r;
pv_regression(3,4) = pv;

[r,pv] = corr(y,y_hat2,'Type','Pearson');
corrs_regression(4,4) = r;
pv_regression(4,4) = pv;

% save 
save('corrs_regression_riboseq','corrs_regression')
save('pv_regressionn_riboseq','pv_regression')
save('y_alln_riboseq','y_all')
save('y_hat_all_riboseq','y_hat_all')
save('y_hat2_all_riboseq','y_hat2_all')
save('bint_all_riboseq','bint_all')

% calculate partial correlation
[rho, pv] = partialcorr([non_nans_riboseq,no_nans_ETIP], no_nans_CAI ,'Type','Spearman');
partialcorr_regressor_chlami = [rho(2,1),pv(1,2)];
save('partialcorr_regressor_chlamin_riboseq','partialcorr_regressor_chlami')


% best is with ranked, spearman (1,2) (1,4)
best_CAI = 2;
best_ETIP = 4;
sz = 20;
figure()
subplot(2,1,1)
scatter(y_all(:,2),y_hat_all(:,best_CAI),sz)
h = lsline;
set(h(1),'color','r')
title(sprintf('Regression based on CAI, r=0.60, Pv=0.26*10^-^4'))%,corrs_regression(1,2)))
xlabel('Ranked PA')
ylabel('Predicted Ranked Riboseq')
set(gca,'FontWeight','bold','FontSize',11)
subplot(2,1,2)
scatter(y_all(:,2),y_hat_all(:,best_ETIP),sz)
h = lsline;
set(h(1),'color','r')
title(sprintf('Regression based on CAI and ETIP, r=0.66, Pv=0.35*10^-^5'))%,corrs_regression(1,4)))
xlabel('Ranked PA')
ylabel('Predicted Ranked Riboseq')
set(gca,'FontWeight','bold','FontSize',11)

