%% typical groups
load('genes_names.mat')
load('best_start_ETIP.mat')
load('best_start_constrains.mat')
load(sprintf('res_ETIP_start%d_%d.mat',best_start_ETIP,best_start_constrains))

[mRNA_l_count,mRNA_l_edges] = histcounts(params(:,1));
[S16_count,S16_edges] = histcounts(params(:,2));
[pos_count,pos_edges] = histcounts(params(:,3));
[const_count,const_edges] = histcounts(params(:,4));

% peaks higher then 10%:
mRNA_l_peaks = floor(mRNA_l_edges(find(mRNA_l_count./length(params)>0.1)+1));
S16_peaks = floor(S16_edges(find(S16_count./length(params)>0.1)+1));
pos_peaks = floor(pos_edges(find(pos_count./length(params)>0.1)+1));
const_peaks = floor(const_edges(find(const_count./length(params)>0.1)+1));

typical_gr_mRNA_ETIP = []; 
for mRNA_l_p = 1:length(mRNA_l_peaks)
    typical_gr_mRNA_ETIP = [typical_gr_mRNA_ETIP,find(params(:,1)==mRNA_l_peaks(mRNA_l_p))];
end

typical_gr_16S_ETIP = []; 
for S16_p = 1:length(S16_peaks)
    typical_gr_16S_ETIP = [typical_gr_16S_ETIP,find(params(:,2)==S16_peaks(S16_p))];
end

typical_gr_pos_ETIP = []; 
for pos_p = 1:length(pos_peaks)
    typical_gr_pos_ETIP = [typical_gr_pos_ETIP,find(params(:,3)==pos_peaks(pos_p))];
end

typical_gr_const_ETIP = []; 
for const_p = 1:length(const_peaks)
    typical_gr_const_ETIP = [typical_gr_const_ETIP,find(params(:,1)==const_peaks(const_p))];
end

% intersection between the groups
[typical_groups,~]=intersect(typical_gr_mRNA_ETIP,typical_gr_16S_ETIP);
[typical_groups,~]=intersect(typical_groups,typical_gr_pos_ETIP);
[typical_groups,~]=intersect(typical_groups,typical_gr_const_ETIP);

save('typical_groups','typical_groups')

% check fourtlets of parameters
fourtlets = {};
fourt_count = zeros(length(typical_groups),1);
count = 0;
for fourt = 1:length(typical_groups)
  cur_fourt = [params(typical_groups(fourt),1),params(typical_groups(fourt),2),params(typical_groups(fourt),3),params(typical_groups(fourt),4)];
  exists_f = 0;
  for f = 1:length(fourtlets)
      if fourtlets{f} == cur_fourt
          exists_f = 1;
          what_f = f;            
      end
  end
  if exists_f == 0
     count = count+1;
     fourtlets = [fourtlets;cur_fourt];
     fourt_count(count) = fourt_count(count)+1;
  else
      fourt_count(what_f) = fourt_count(what_f)+1;
  end
end
fourt_count= fourt_count(1:count,1);
  
gr_fourtlets = cell(length(fourt_count),1);
for fourt = 1:length(fourt_count)
  curr_gr_fourt = [];
  params = fourtlets{fourt,:};
  for gr = 1:length(typical_groups)
      if params == [params{2,3}(typical_groups(gr),1),params{2,3}(typical_groups(gr),2),params{2,3}(typical_groups(gr),3),params{2,3}(typical_groups(gr),4)]
         curr_gr_fourt = [curr_gr_fourt;typical_groups(gr)];
      end
  end
  gr_fourtlets{fourt}=curr_gr_fourt;
end

% typical genes names
typical_genes_names = cell(length(fourt_count),1);
for fourt = 1:length(fourt_count)
  curr_gene_names = {};
  for g= 1: length(gr_fourtlets{fourt})
      curr_gene_names = [curr_gene_names,genes_names(gr_fourtlets{fourt}(g))];
  end
  typical_genes_names{fourt} = curr_gene_names;

end
save('typical_genes_names','typical_genes_names')
save('gr_fourtlets','gr_fourtlets')
save('fourt_count','fourt_count')

%% non typical groups
non_typical_groups = setdiff(1:number_groups,typical_groups);
save('non_typical_groups','non_typical_groups')
non_fourtlets = {};
non_fourt_count = zeros(length(non_typical_groups),1);
count = 0;
for fourt = 1:length(non_typical_groups)
  cur_fourt = [params(non_typical_groups(fourt),1),params(non_typical_groups(fourt),2),params(non_typical_groups(fourt),3),params(non_typical_groups(fourt),4)];
  exists_f = 0;
  for f = 1:length(non_fourtlets)
      if non_fourtlets{f} == cur_fourt
          exists_f = 1;
          what_f = f;            
      end
  end
  if exists_f == 0
     count = count+1;
     non_fourtlets = [non_fourtlets;cur_fourt];
     non_fourt_count(count) = non_fourt_count(count)+1;
  else
      non_fourt_count(what_f) = non_fourt_count(what_f)+1;
  end
end
non_fourt_count= non_fourt_count(1:count,1);
  
non_gr_fourtlets = cell(length(non_fourt_count),1);
for fourt = 1:length(non_fourt_count)
  curr_gr_fourt = [];
  params = non_fourtlets{fourt,:};
  for gr = 1:length(non_typical_groups)
      if params == [params{2,3}(non_typical_groups(gr),1),params{2,3}(non_typical_groups(gr),2),params{2,3}(non_typical_groups(gr),3),params{2,3}(non_typical_groups(gr),4)]
         curr_gr_fourt = [curr_gr_fourt;non_typical_groups(gr)];
      end
  end
  non_gr_fourtlets{fourt}=curr_gr_fourt;
end

% non- typical genes names
non_typical_genes_names = cell(length(non_fourt_count),1);
for fourt = 1:length(non_fourt_count)
  curr_gene_names = {};
  for g= 1: length(non_gr_fourtlets{fourt})
      curr_gene_names = [curr_gene_names,genes_names(non_gr_fourtlets{fourt}(g))];
  end
  non_typical_genes_names{fourt} = curr_gene_names;
end

save('non_typical_genes_names','non_typical_genes_names')
save('non_typical_groups','non_typical_groups')

%% chlami typical groups
load('chlami_data.mat')
chlami_PA_gr = nan(number_groups,1);
chlami_CAI_gr = nan(number_groups,1);
for gr = 1:number_groups
    gr_ind = find(chlami_data.chlami_gr==gr);
    if ~isempty(gr_ind)
        chlami_PA_gr(gr) = chlami_data.chlami_mean_PA(gr_ind(1));
        chlami_CAI_gr(gr) = chlami_data.chlami_CAI(gr_ind(1));
    end
end
save('chlami_PA_gr','chlami_PA_gr')
save('chlami_CAI_gr','chlami_CAI_gr')

rand_mean_PA_chlami = zeros(100,1);
rand_mean_CAI_chlami = zeros(100,1);
mean_PA_typical_chlami = nanmean(chlami_PA_gr(typical_groups));
mean_CAI_typical_chlami = nanmean(chlami_CAI_gr(typical_groups));

for i = 1:100
    rand_i = randperm(number_groups);
    rand_mean_CAI_chlami(i) = nanmean(chlami_CAI_gr(rand_i(1:length(typical_groups))));
    rand_mean_PA_chlami(i) = nanmean(chlami_PA_gr(rand_i(1:length(typical_groups))));
end
PV_PA_typical = sum(mean_PA_typical_chlami<rand_mean_PA_chlami)/100;
PV_CAI_typical = sum(mean_CAI_typical_chlami<rand_mean_CAI_chlami)/100;

save('PV_PA_typical','PV_PA_typical')
save('PV_CAI_typical','PV_CAI_typical')

rand_mean_PA_chlami_non = zeros(100,1);
rand_mean_CAI_chlami_non = zeros(100,1);
mean_PA_nontypical_chlami = nanmean(chlami_PA_gr(non_typical_groups));
mean_CAI_nontypical_chlami = nanmean(chlami_CAI_gr(non_typical_groups));
for i = 1:100
    rand_i = randperm(number_groups);
    rand_mean_CAI_chlami_non(i) = nanmean(chlami_CAI_gr(rand_i(1:length(non_typical_groups))));
    rand_mean_PA_chlami_non(i) = nanmean(chlami_PA_gr(rand_i(1:length(non_typical_groups))));
end
PV_PA_nontypical = sum(mean_PA_nontypical_chlami>rand_mean_PA_chlami_non)/100;
PV_CAI_nontypical = sum(mean_CAI_nontypical_chlami>rand_mean_CAI_chlami_non)/100;

save('PV_PA_nontypical','PV_PA_nontypical')
save('PV_CAI_nontypical','PV_CAI_nontypical')

