load('possible_seq') % all the possible combination of nucleotides A/T/G/C for a sequence length of 5 nt.
load('energy_map_SD') % the cofold energy with SD sequence with all the possible sequences.
load('number_groups.mat')
position_upstream_max = 50;
len_seq_SD = 5;
for gr = 1:number_groups
    load(sprintf('group%d.mat',gr));
    group_score_matrix = zeros(height(new_group),position_upstream_max);
    for gene = 1:height(new_group)
        nt_seq = group.Genes_energy{gene}(1:position_upstream_max);
        gene_score_matrix = zeros(1,position_upstream_max-len_seq_SD);
        for pos = 1:position_upstream_max-len_seq_SD 
            gene_score_matrix(1,pos)=str2double(energy_map_SD.get(nt_seq(pos:pos+len_seq_SD)));
        end
        group_score_matrix(gene,:) = gene_score_matrix;
    end
    save(sprintf('group%d_score_matrix.mat',gr),'group_score_matrix')
end

load('typical_groups.mat')
load('non_typical_groups.mat')

count = 0;
num_zeros=zeros(number_groups,1);
num_mean_zeros = zeros(number_groups,1);
SD_positions_typical = zeros(length(typical_groups),2);
typical_groups = shared_typ_params_minusfold;
for gr = 1:length(typical_groups)
    count = count + 1;
    load(sprintf('group%d_score_matrix.mat',typical_groups(gr)))
    num_zeros(typical_groups(gr)) = length(find(nansum(group_score_matrix,2)==0))/size(group_score_matrix,1);
    mean_group_score_matrix = nanmean(group_score_matrix);
    [m,i] = min(mean_group_score_matrix);
    if m == 0 && i == 1
        num_mean_zeros(typical_groups(gr)) = 1;
        SD_positions_typical(count,1)=0;
        SD_positions_typical(count,2)=nan;
    else
        SD_positions_typical(count,1)=m;
        SD_positions_typical(count,2)=i;
    end
end

save('SD_positions_typical','SD_positions_typical')
count = 0;
SD_positions_nontypical = zeros(length(non_typical_groups),2);
for gr = 1:length(non_typical_groups)
    count = count + 1;
    load(sprintf('group%d_score_matrix.mat',gr))
    num_zeros(gr_i) = length(find(nansum(group_score_matrix,2)==0))/size(group_score_matrix,1);
    mean_group_score_matrix = nanmean(group_score_matrix);
    [m,i] = min(mean_group_score_matrix);
    if m == 0 && i == 1
        num_mean_zeros(gr_i) = 1;
        SD_positions_nontypical(count,1)=0;
        SD_positions_nontypical(count,2)=nan;
    else
        SD_positions_nontypical(count,1)=m;
        SD_positions_nontypical(count,2)=i;
    end
end

save('SD_positions_nontypical','SD_positions_nontypical')

typical_SD = mean(SD_positions_typical);
nontypical_SD = mean(SD_positions_nontypical);

save('typical_SD','typical_SD')
save('nontypical_SD','nontypical_SD')

count = 0;
SD_positions_all = zeros(number_groups,2);
for gr = 1:number_groups
    count = count + 1;
    load(sprintf('group%d_score_matrix.mat',gr))
    mean_group_score_matrix = nanmean(group_score_matrix);
    [m,i] = min(mean_group_score_matrix);
    SD_positions_all(count,1)=m;
    SD_positions_all(count,2)=i;
end


count = 0;
SD_positions_all_min = zeros(number_groups,2);
for gr = 1:number_groups
    count = count + 1;
    load(sprintf('group%d_score_matrix.mat',gr))
    best_scores_genes = zeros(size(group_score_matrix,1),2);
    for gene = 1:size(group_score_matrix,1)
        [m,i] = min(group_score_matrix(gene,:));
        if m == 0
            best_scores_genes(gene,1) = nan;
            best_scores_genes(gene,2) = nan;
        else
            best_scores_genes(gene,1) = m;
            best_scores_genes(gene,2) = i;
        end
    end
    SD_positions_all_min(count,:) = nanmean(best_scores_genes);
end

typical_score_SD = mean(SD_positions_all_min(typical_groups,1));
typical_pos_SD = mean(SD_positions_all_min(typical_groups,2));
nontypical_score_SD = mean(SD_positions_all_min(non_typical_groups,1));
nontypical_pos_SD = mean(SD_positions_all_min(non_typical_groups,2));

save('typical_score_SD','typical_score_SD')
save('typical_pos_SD','typical_pos_SD')

save('nontypical_score_SD','nontypical_score_SD')
save('nontypical_pos_SD','nontypical_pos_SD')

% chlami
load('possible_seq.mat')
load('energy_map_SD.mat')
load('chlami_genes.mat')
load('chlami_chloro_num.mat')
chlami_genes_energy = cell(length(chlami_genes),1);
load(sprintf('chloro%d.mat',chlami_chloro_num))

group_score_matrix = zeros(length(chlami_genes),position_upstream_max-len_seq_SD);
for gene = 1:length(chlami_genes)
    nt_seq = chlami_data.genes_energy{gene}(1:position_upstream_max);
    gene_score_matrix = zeros(1,position_upstream_max-len_seq_SD);
    for pos = 1:position_upstream_max-len_seq_SD  
        gene_score_matrix(1,pos)=str2double(energy_map_SD.get(nt_seq(pos:pos+len_seq_SD)));
    end
    group_score_matrix(gene,:) = gene_score_matrix;
end

save('chlami_score_matrix.mat','group_score_matrix')
mean_group_score_matrix = mean(group_score_matrix);
[m,i] = min(mean_group_score_matrix);
count_zeros_chlami = length(find(nansum(group_score_matrix,2)==0))/size(group_score_matrix,1);
best_score_genes_chlami = zeros(size(group_score_matrix,1),2);
for g = 1:size(group_score_matrix,1)     
    [m,i] =  min(group_score_matrix(g,:));
    best_score_genes_chlami(g,:) = [m,i];
end
for g = 1:size(group_score_matrix,1)
    if best_score_genes_chlami(g,:) == [0,1]
        best_score_genes_chlami(g,:) = [0,nan];
    end
end

chlami_SD_score_gr = nan(number_groups,2);
for gr = 1:number_groups
    gr_ind = find(chlami_data.chlami_groups==gr);
    if ~isempty(gr_ind)
        chlami_SD_score_gr(gr,:) = best_score_genes_chlami(gr_ind(1),:);
    end
end

mean_chlami_SD_score_typical_gr = nanmean(chlami_SD_score_gr(typical_groups,:));
mean_chlami_SD_score_nontypical_gr = nanmean(chlami_SD_score_gr(non_typical_groups,:));
save('chlami_SD_score_typical_gr_mean','chlami_SD_score_typical_gr_mean')
save('chlami_SD_score_nontypical_gr_mean','chlami_SD_score_typical_gr_mean')


rand_mean_SD_score_chlami = zeros(100,1);
rand_mean_SD_pos_chlami = zeros(100,1);

for i = 1:100
    rand_i = randperm(number_groups);
    rand_mean_SD_score_chlami(i) = nanmean(chlami_SD_score_gr(rand_i(1:length(typical_groups))));
    rand_mean_SD_pos_chlami(i) = nanmean(chlami_SD_score_gr(rand_i(1:length(typical_groups))));
end
PV_SD_score_typical = sum(mean_chlami_SD_score_typical_gr(1)<rand_mean_SD_score_chlami)/100;
PV_SD_pos_typical = sum(mean_chlami_SD_score_typical_gr(2)<rand_mean_SD_pos_chlami)/100;

save('PV_SD_score_typical','PV_SD_score_typical')
save('PV_SD_pos_typical','PV_SD_pos_typical')

rand_mean_SD_score_chlami_non = zeros(100,1);
rand_mean_SD_pos_chlami_non = zeros(100,1);

for i = 1:100
    rand_i = randperm(number_groups);
    rand_mean_SD_score_chlami_non(i) = nanmean(chlami_SD_score_gr(rand_i(1:length(non_typical_groups))));
    rand_mean_SD_pos_chlami_non(i) = nanmean(chlami_SD_score_gr(rand_i(1:length(non_typical_groups))));
end
PV_SD_score_nontypical = sum(mean_chlami_SD_score_nontypical_gr(1)<rand_mean_SD_score_chlami_non)/100;
PV_SD_pos_nontypical = sum(mean_chlami_SD_score_nontypical_gr(2)<rand_mean_SD_pos_chlami_non)/100;

save('PV_SD_score_nontypical','PV_SD_score_nontypical')
save('PV_SD_pos_nontypical','PV_SD_pos_nontypical')

