function Calculate_MSA_fold_energy_Zscore(gr,maxRand)

%% calculating MSA
load(sprintf('group%d.mat',gr));
[Sequences_AA,Sequences_nt3,Sequences_nt5,Names,l_UTR3,l_UTR5] = create_fasta(group);
% ORF MSA (Amino Acids)
fastawrite(sprintf('gr%d_AA_MSA.fa',gr),Names,Sequences_AA)
[~,~] = system(sprintf('clustalo -type=PROTEIN -outputorder=INPUT -i gr%d_AA.fa  -o gr%d_AA_MSA.fa --outfmt=fasta --auto',gr,gr));
% UTR3 MSA (Nucleotides)
fastawrite(sprintf('gr%d_UTR3.fa',gr),Names,Sequences_nt3)
[~,~] = system(sprintf('clustalo  -t DNA -i gr%d_UTR3.fa  -o gr%d_UTR3_MSA.fa --outfmt=fasta --auto',gr,gr));
% UTR5 MSA (Nucleotides)
fastawrite(sprintf('gr%d_UTR5.fa',gr),Names,Sequences_nt5)
[~,~] = system(sprintf('clustalo  -t DNA -i gr%d_UTR5.fa  -o gr%d_UTR5_MSA.fa --outfmt=fasta --auto',gr,gr));

%% creating real MSA cut for later use in fold
MSA_ORF_AA_raw = fastaread(sprintf('gr%d_AA_MSA.fa',gr));
MSA_UTR3_nt_raw = fastaread(sprintf('gr%d_UTR3_MSA.fa',gr));
MSA_UTR5_nt_raw = fastaread(sprintf('gr%d_UTR5_MSA.fa',gr));
MSA_ORF_AA = cell(length(MSA_ORF_AA_raw),1);
MSA_UTR3_nt = cell(length(MSA_UTR3_nt_raw),1);
MSA_UTR5_nt = cell(length(MSA_UTR5_nt_raw),1);
for g = 1:length(MSA_ORF_AA_raw)
   MSA_ORF_AA{g} = MSA_ORF_AA_raw(g).Sequence;
   MSA_UTR3_nt{g} = MSA_UTR3_nt_raw(g).Sequence;
   MSA_UTR5_nt{g} = MSA_UTR5_nt_raw(g).Sequence;
end
% Making the MSA_AA into MSA_nt and changing the MSA from strings to mat of numbers
[MSA_ORF_nt,MSA_ORF_AA_num,MSA_ORF_nt_num,MSA_UTR3_nt_num,MSA_UTR5_nt_num,numAA_noIndel] = MSA_AA2nt_2num(MSA_ORF_AA,MSA_UTR3_nt,MSA_UTR5_nt,new_group);
% Taking out indels and cuting for desired length of gene for fold
[MSA_gathered3,MSA_gathered5,build_energy_map3,build_energy_map5,build_rand_map3,build_rand_map5,nans_energy_mat3,nans_energy_mat5,ATG_pos,stop_pos,Names,ATG_pos_add,stop_pos_reduce] = MSA_IndelsMap(MSA_UTR3_nt,MSA_UTR5_nt,MSA_ORF_nt,MSA_ORF_AA);
% compute entropy
Entropy_orig3 = sum(Entropy_MSA(MSA_gathered3));
Entropy_orig5 = sum(Entropy_MSA(MSA_gathered5));
save(sprintf('gr%d_MSA',gr),'MSA_ORF_AA','MSA_ORF_nt','MSA_UTR3_nt','MSA_UTR5_nt','MSA_ORF_AA_num','MSA_ORF_nt_num','MSA_UTR3_nt_num','MSA_UTR5_nt_num','MSA_gathered3','MSA_gathered5','build_energy_map3','build_energy_map5','build_rand_map3','build_rand_map5','nans_energy_mat3','nans_energy_mat5','Names','numAA_noIndel','Entropy_orig3','Entropy_orig5','ATG_pos','stop_pos','l_UTR3','l_UTR5')
%% creating fasta
fastawrite(sprintf('gr%d_MSA_gathered3.fa',gr),Names,MSA_gathered3)
fastawrite(sprintf('gr%d_MSA_gathered5.fa',gr),Names,MSA_gathered5)

%% creating rando       
Entropies = zeros(maxRand+1,2);
Entropies(1,1)= Entropy_orig5;
Entropies(1,2) = Entropy_orig3;
% num of rows and cols
numGenes = length(MSA_ORF_AA); numAA = length(MSA_ORF_AA{1}); numNt3 = length(MSA_UTR3_nt{1}); numNt5 = length(MSA_UTR5_nt{1});
for r = 1:maxRand 
   cur_MSA_ORF_nt_num = MSA_ORF_nt_num;
   cur_MSA_UTR3_nt_num = MSA_UTR3_nt_num;
   cur_MSA_UTR5_nt_num = MSA_UTR5_nt_num;           
   [MSA_rand3,MSA_rand5,MSA_ORF_rand_nt_num,MSA_UTR3_rand_nt_num,MSA_UTR5_rand_nt_num,flips_ORF,flips_UTR3,flips_UTR5] = random_MSA(cur_MSA_ORF_nt_num,MSA_ORF_AA_num,cur_MSA_UTR3_nt_num,cur_MSA_UTR5_nt_num,numAA,numGenes,build_rand_map3,build_rand_map5,numNt3,numNt5,numAA_noIndel,l_UTR3,l_UTR5); 
   Entropy_rand3 = sum(Entropy_MSA(MSA_rand3));
   Entropy_rand5 = sum(Entropy_MSA(MSA_rand5));
   Entropies(r+1,1)= Entropy_rand5;
   Entropies(r+1,2) = Entropy_rand3;
   save(sprintf('gr%d_MSA_rand%d',gr,r),'MSA_rand3','MSA_rand5','MSA_ORF_rand_nt_num','MSA_UTR3_rand_nt_num','MSA_UTR5_rand_nt_num','flips_ORF','flips_UTR3','flips_UTR5','Entropy_rand3','Entropy_rand5')
   save(sprintf('gr%d_entropies.mat',gr),'Entropies')
   %% creating fasta
  fastawrite(sprintf('gr%d_MSA_rand%d_3.fa',gr,r),Names,MSA_rand3)
  fastawrite(sprintf('gr%d_MSA_rand%d_5.fa',gr,r),Names,MSA_rand5)
end

%% inserting the fasta file to RNAfold code
% Real
system(sprintf('/tamir1/stav_carmel/ViennaRNASW/RNASWfold -w 39 -v false < /tamir1/stav_carmel/gr_by_names/struct_newc/gr%d_MSA_gathered5.fa > /tamir1/stav_carmel/gr_by_names/struct_newc2/gr%d_fold5.txt',gr,gr));
message = sprintf('finished energies5 group %d',gr);
fprintf('%s\n',message); 
system(sprintf('/tamir1/stav_carmel/ViennaRNASW/RNASWfold -w 39 -v false < /tamir1/stav_carmel/gr_by_names/struct_newc/gr%d_MSA_gathered3.fa > /tamir1/stav_carmel/gr_by_names/struct_newc2/gr%d_fold3.txt',gr,gr));
message = sprintf('finished energies3 group %d',gr);
fprintf('%s\n',message);
energies5 = load(sprintf('/tamir1/stav_carmel/gr_by_names/struct_newc2/gr%d_fold5.txt',gr));
energies3 = load(sprintf('/tamir1/stav_carmel/gr_by_names/struct_newc2/gr%d_fold3.txt',gr));
load(sprintf('/tamir1/stav_carmel/gr_by_names/struct_newc/gr%d_MSA.mat',gr))
[energy_mat3,energy_mat5] = energy_back2indels(energies3,energies5,build_energy_map3,build_energy_map5,nans_energy_mat3,nans_energy_mat5);
save(sprintf('/tamir1/stav_carmel/gr_by_names/struct_newc2/gr%d_energy_mat',gr),'energy_mat3','energy_mat5','energies3','energies5')

% Rand
for r = 1:maxRand
    [~,~] = system(sprintf('RNASWfold -w 39 -v false < gr%d_MSA_rand%d_3.fa > gr%d_fold_rand%d_3.txt',gr,r,gr,r));
    energies3_rand = load(sprintf('gr%d_fold_rand%d_3.txt',gr,r));
    [~,~] = system(sprintf('RNASWfold -w 39 -v false <gr%d_MSA_rand%d_5.fa > gr%d_fold_rand%d_5.txt',gr,r,gr,r));
    energies5_rand = load(sprintf('gr%d_fold_rand%d_5.txt',gr,r));
    [energy_rand_mat3,energy_rand_mat5] = energy_back2indels(energies3_rand,energies5_rand,build_energy_map3,build_energy_map5,nans_energy_mat3,nans_energy_mat5);
    save(sprintf('gr%d_energy_mat_rand%d',gr,r),'energy_rand_mat3','energy_rand_mat5','energies3_rand','energies5_rand')
end

%% Z score and Zscore energy profile
%Zscore MSA
mean_energy_real3 = nanmean(energy_mat3);
mean_energy_real5 = nanmean(energy_mat5);
mean_energy_rand3 = nan(maxRand,size(energy_mat3,2));
mean_energy_rand5 = nan(maxRand,size(energy_mat5,2));

%Zscore profile
mean_energy_profile_real3 = nanmean(energies3);
mean_energy_profile_real5 = nanmean(energies5);
mean_energy_profile_rand3 = nan(maxRand,size(energies3,2));
mean_energy_profile_rand5 = nan(maxRand,size(energies5,2));
for r = 1:maxRand
    load(sprintf('gr%d_energy_mat_rand%d.mat',gr,r))
    %Zscore MSA
    mean_energy_rand3(r,:) = nanmean(energy_rand_mat3);      
    mean_energy_rand5(r,:) = nanmean(energy_rand_mat5);
    %Zscore profile
    mean_energy_profile_rand3(r,:) = nanmean(energies3_rand);      
    mean_energy_profile_rand5(r,:) = nanmean(energies5_rand);  
end
%Zscore MSA
MSA_Zscore3 = (mean_energy_real3 - nanmean(mean_energy_rand3)) ./ nanstd(mean_energy_rand3);
MSA_Zscore5 = (mean_energy_real5 - nanmean(mean_energy_rand5)) ./ nanstd(mean_energy_rand5);
%Zscore profile
profile_Zscore3 = (mean_energy_profile_real3 - nanmean(mean_energy_profile_rand3)) ./ nanstd(mean_energy_profile_rand3);
profile_Zscore5 = (mean_energy_profile_real5 - nanmean(mean_energy_profile_rand5)) ./ nanstd(mean_energy_profile_rand5);

numGenes = length(MSA_ORF_nt);
not_indel_am5 = zeros(length(MSA_Zscore5),1);
not_indel_am3 = zeros(length(MSA_Zscore3),1);
count = 0;
for pos = 1:length(MSA_Zscore5)
    count = count + 1;
    if pos < ATG_pos
        not_indel_am5(count)=sum(MSA_UTR5_nt_num(:,pos)~=16);
    else
        posi = pos - ATG_pos +1;
        not_indel_am5(count)=sum(MSA_ORF_nt_num(:,posi)~=16);
    end
end
count = 0;
for pos = 1: length(MSA_Zscore3)
    count = count + 1;
    if pos <= stop_pos
        not_indel_am3(count)=sum(MSA_ORF_nt_num(:,pos)~=16);
    else
        posi = pos - stop_pos;
        not_indel_am3(count)=sum(MSA_UTR3_nt_num(:,posi)~=16);
    end
end
not_indel_perc3 = (not_indel_am3*100)/numGenes;
not_indel_perc5 = (not_indel_am5*100)/numGenes;

% put nan where there are more than 50% genes with nan
nans_i3 = zeros(size(profile_Zscore3,2),1);
for pos = 1:size(profile_Zscore3,2)
    if (length(find(isnan(energies3(:,pos))))*100)/size(energies3,1)>50
        nans_i3(pos) = 1;
    end
end
nans_i5 = zeros(size(profile_Zscore5,2),1);
for pos = 1:size(profile_Zscore5,2)
    if (length(find(isnan(energies5(:,pos))))*100)/size(energies5,1)>50
        nans_i5(pos) = 1;
    end
end
profile_Zscore3(nans_i3==1)= nan;
profile_Zscore5(nans_i5==1)= nan;
 
%% Pvalue of energy profile
UTR5_p = zeros(2,size(energies5,2));
UTR5_for = zeros(1,size(energies5,2));
UTR5_against = zeros(1,size(energies5,2));

for nt = 1:size(energies5,2)
    UTR5_p(1,nt)=length(find(mean_energy_profile_rand5(:,nt)<=mean_energy_profile_real5(1,nt)))/50;
    UTR5_p(2,nt)=length(find(mean_energy_profile_rand5(:,nt)>=mean_energy_profile_real5(1,nt)))/50;
end
for i=1:size(energies5,2)
    if UTR5_p(1,i)<=0.05
       UTR5_for(1,i)=100;
    elseif UTR5_p(2,i)<=0.05
       UTR5_against(1,i)=-100;
    end
end

UTR3_p = zeros(2,size(energies3,2));
UTR3_for = zeros(1,size(energies3,2));
UTR3_against = zeros(1,size(energies3,2));

for nt = 1:size(energies3,2)
    UTR3_p(1,nt)=length(find(mean_energy_profile_rand3(:,nt)<=mean_energy_profile_real3(1,nt)))/50;
    UTR3_p(2,nt)=length(find(mean_energy_profile_rand3(:,nt)>=mean_energy_profile_real3(1,nt)))/50;
end
for i=1:size(energies3,2)
    if UTR3_p(1,i)<=0.05
       UTR3_for(1,i)=100;
    elseif UTR3_p(2,i)<=0.05
       UTR3_against(1,i)=-100;
    end
end
UTR5_map = UTR5_against+UTR5_for;
UTR3_map = UTR3_against+UTR3_for;
UTR3_map(nans_i3==1)= 0;
UTR5_map(nans_i5==1)= 0;
save(sprintf('gr%d_Zscore',gr),'MSA_Zscore3','stop_pos','MSA_Zscore5','ATG_pos','not_indel_perc3','not_indel_perc5','profile_Zscore3','profile_Zscore5','UTR3_map','UTR5_map','UTR3_p','UTR5_p');
end

