function [MSA_ORF_nt,MSA_ORF_AA_num,MSA_ORF_nt_num,MSA_UTR3_nt_num,MSA_UTR5_nt_num,numAA_noIndel] = MSA_AA2nt_2num(MSA_ORF_AA,MSA_UTR3_nt,MSA_UTR5_nt,new_group)
    numGenes = size(MSA_ORF_AA,1);
    numAA = length(MSA_ORF_AA{1});
    numNtORF = numAA*3;
    numNtUTR3 = length(MSA_UTR3_nt{1});
    numNtUTR5 = length(MSA_UTR5_nt{1});
    MSA_ORF_nt = cell(numGenes,1);
    MSA_ORF_AA_num = zeros(numGenes,numAA);
    MSA_ORF_nt_num = zeros(numGenes,numNtORF);
    MSA_UTR3_nt_num = zeros(numGenes,numNtUTR3);
    MSA_UTR5_nt_num = zeros(numGenes,numNtUTR5);
    not_indel_count = zeros(numGenes,1);
    for g = 1:numGenes   
        MSA_ORF_AA_num(g,:)=aa2int(MSA_ORF_AA{g});
        MSA_UTR3_nt_num(g,:)=nt2int(MSA_UTR3_nt{g});
        MSA_UTR5_nt_num(g,:)=nt2int(MSA_UTR5_nt{g});
        not_indel = regexp(MSA_ORF_AA{g},'\w');
        stop_i = regexp(MSA_ORF_AA{g},'*');
        not_indel = [not_indel,stop_i];
        not_indel_count(g) = length(not_indel);
        nt_seq='';
        nt_seq(1:numNtORF)='-';
        new_ind=sort([not_indel.*3-2,not_indel.*3-1,not_indel.*3]);
        nt_seq(new_ind)=new_group.ORF{g};
        MSA_ORF_nt{g} = nt_seq;
        MSA_ORF_nt_num(g,:) = nt2int(nt_seq);
    end
    numAA_noIndel = median(not_indel_count);
end
