function [MSA_gathered3,MSA_gathered5,build_energy_map3,build_energy_map5,build_rand_map3,build_rand_map5,nans_energy_mat3,nans_energy_mat5,ATG_pos,stop_pos,Names,ATG_pos_add,stop_pos_reduce] = MSA_IndelsMap(MSA_UTR3,MSA_UTR5,MSA_ORF_nt,MSA_ORF_AA)
    numAA = length(MSA_ORF_AA{1});
    numNtORF = numAA*3;
    numNtUTR3 = length(MSA_UTR3{1});
    numNtUTR5 = length(MSA_UTR5{1});
    numGenes = size(MSA_ORF_nt,1);
    MSA_gathered3 = cell(numGenes,1);
    MSA_gathered5 = cell(numGenes,1);
    build_energy_map3 = cell(numGenes,1);
    build_energy_map5 = cell(numGenes,1);
    build_rand_map3 = cell(numGenes,1);
    build_rand_map5 = cell(numGenes,1);
    Names = cell(numGenes,1);
    ATG_pos_add_all = [];
    stop_pos_reduce_all = [];
    for g = 1:numGenes
       % save not indel map for reconstruction 
       not_indel_UTR3 = regexp(MSA_UTR3{g},'\w');
       indel_UTR3 = setdiff([1:numNtUTR3],not_indel_UTR3);
       not_indel_UTR5 = regexp(MSA_UTR5{g},'\w');
       indel_UTR5 = setdiff([1:numNtUTR5],not_indel_UTR5);
       not_indel_ORF = regexp(MSA_ORF_nt{g},'\w');
       % hoe many indels are before ATG
       ATG_pos_add_all = [ATG_pos_add_all;not_indel_ORF(1)];
       stop_pos_reduce_all = [stop_pos_reduce_all;numNtORF-not_indel_ORF(end)];
       indel_ORF = setdiff([1:numNtORF],not_indel_ORF);
       MSA_gathered5{g} = [MSA_UTR5{g}(indel_UTR5),MSA_UTR5{g}(not_indel_UTR5),MSA_ORF_nt{g}(not_indel_ORF),MSA_ORF_nt{g}(indel_ORF)];
       MSA_gathered3{g} = [MSA_ORF_nt{g}(indel_ORF),MSA_ORF_nt{g}(not_indel_ORF),MSA_UTR3{g}(not_indel_UTR3),MSA_UTR3{g}(indel_UTR3)];
      % cut the last 38 indices, so search for the max 38 values and than cut them out
       build_energy_map5{g}=[indel_UTR5,not_indel_UTR5,not_indel_ORF+numNtUTR5,indel_ORF+numNtUTR5]; % for the energies back into the right places
       [sorted5,ind5] = sort(build_energy_map5{g});
       build_energy_map5{g}=build_energy_map5{g}(ind5(1:end-39+1));
       build_energy_map3{g}=[indel_ORF,not_indel_ORF,not_indel_UTR3+numNtORF,indel_UTR3+numNtORF]; % for the energies back into the right places
       [sorted3,ind3] = sort(build_energy_map3{g});
       build_energy_map3{g}=build_energy_map3{g}(ind3(1:end-39+1));
       build_rand_map5{g}={indel_UTR5,not_indel_UTR5,not_indel_ORF,indel_ORF}; % for cutting the random
       build_rand_map3{g}={indel_ORF,not_indel_ORF,not_indel_UTR3,indel_UTR3}; % for cutting the random
       Names{g}=sprintf('%d',g);
    end
    ATG_pos_add = median(ATG_pos_add_all);
    stop_pos_reduce = median(stop_pos_reduce_all);
    ATG_pos = numNtUTR5+1; 
    stop_pos = numNtORF; % the end of the stop codon
    nans_energy_mat5 = nan(numGenes,numNtUTR5+numNtORF-39+1);
    nans_energy_mat3 = nan(numGenes,numNtORF+numNtUTR3-39+1);
end