function Zscore_Random
    load('number_groups.mat')
    ratios5_all_groups = [];
    ratios3_all_groups = [];
    
    for gr = 1:number_groups
        load(sprintf('gr%d_MSA.mat',gr))
        load(sprintf('gr%d_energy_mat_rand%d.mat',gr,1)) % taking the first random
        load(sprintf('gr%d_Zscore.mat',gr))
        %Zscore MSA
        mean_energy_real3 = nanmean(energy_rand_mat3);
        mean_energy_real5 = nanmean(energy_rand_mat5);
        mean_energy_rand3 = nan(50,size(energy_rand_mat3,2));
        mean_energy_rand5 = nan(50,size(energy_rand_mat5,2));
    
        %Zscore profile
        mean_energy_profile_real3 = nanmean(energies3_rand);
        mean_energy_profile_real5 = nanmean(energies5_rand);
        mean_energy_profile_rand3 = nan(50,size(energies3_rand,2));
        mean_energy_profile_rand5 = nan(50,size(energies5_rand,2));
        for r = 2:50
            load(sprintf('gr%d_energy_mat_rand%d.mat',gr,r))
            %Zscore MSA
            mean_energy_rand3(r,:) = nanmean(energy_rand_mat3);      
            mean_energy_rand5(r,:) = nanmean(energy_rand_mat5);
            %Zscore profile
            mean_energy_profile_rand3(r,:) = nanmean(energies3_rand);      
            mean_energy_profile_rand5(r,:) = nanmean(energies5_rand);  
        end
        %Zscore MSA
        MSA_Zscore3_rand = (mean_energy_real3 - nanmean(mean_energy_rand3)) ./ nanstd(mean_energy_rand3);
        MSA_Zscore5_rand = (mean_energy_real5 - nanmean(mean_energy_rand5)) ./ nanstd(mean_energy_rand5);
        %Zscore profile
        profile_Zscore3_rand = (mean_energy_profile_real3 - nanmean(mean_energy_profile_rand3)) ./ nanstd(mean_energy_profile_rand3);
        profile_Zscore5_rand = (mean_energy_profile_real5 - nanmean(mean_energy_profile_rand5)) ./ nanstd(mean_energy_profile_rand5);
    
        numGenes = size(MSA_Zscore5_rand,1);
        not_indel_am5 = zeros(length(MSA_Zscore5_rand),1);
        not_indel_am3 = zeros(length(MSA_Zscore3_rand),1);
    
        not_indel_perc3 = (not_indel_am3*100)/numGenes;
        not_indel_perc5 = (not_indel_am5*100)/numGenes;
    
        % put nan where there are more than 50% genes with nan
        nans_i3 = zeros(length(profile_Zscore3_rand),1);
        for pos = 1:length(profile_Zscore3_rand)
            if (length(find(isnan(energies3_rand(:,pos))))*100)/size(energies3_rand,1)>50
                nans_i3(pos) = 1;
            end
        end
        nans_i5 = zeros(length(profile_Zscore5_rand),1);
        for pos = 1:length(profile_Zscore5_rand)
            if (length(find(isnan(energies5_rand(:,pos))))*100)/size(energies5_rand,1)>50
                nans_i5(pos) = 1;
            end
        end
        profile_Zscore3_rand(nans_i3==1)= nan;
        profile_Zscore5_rand(nans_i5==1)= nan;
    
        % calculate ratios for every position in the Zscore
        left_right = 100;
        ratios3 = zeros(1,size(MSA_Zscore3_rand,2)-2*left_right);
        mean_areas3 = zeros(1,size(MSA_Zscore3_rand,2)-2*left_right);
        for pos = left_right+1:size(MSA_Zscore3_rand,2)-left_right
            mean_area = nanmean([MSA_Zscore3_rand(pos-left_right:pos-1),MSA_Zscore3_rand(pos+1:pos+left_right)]);
            mean_areas3(pos) = mean_area;
            ratios3(pos) = MSA_Zscore3_rand(pos)-mean_area;
        end
        ratios3_all_groups = [ratios3_all_groups,ratios3];
    
        ratios5 = zeros(1,size(MSA_Zscore5_rand,2)-2*left_right);
        mean_areas5 = zeros(1,size(MSA_Zscore5_rand,2)-2*left_right);
        for pos = left_right+1:size(MSA_Zscore5_rand,2)-left_right
            mean_area = nanmean([MSA_Zscore5_rand(pos-left_right:pos-1),MSA_Zscore5_rand(pos+1:pos+left_right)]);
            mean_areas5(pos) = mean_area;
            ratios5(pos) = MSA_Zscore5_rand(pos)-mean_area;
        end
        ratios5_all_groups = [ratios5_all_groups,ratios5];
    
        save(sprintf('gr%d_randZscore',gr),'MSA_Zscore3_rand','stop_pos','MSA_Zscore5_rand','ATG_pos','not_indel_perc3','not_indel_perc5','profile_Zscore3_rand','profile_Zscore5_rand','mean_areas5','mean_areas3','ratios5','ratios3');
        
    end
    
    % find the 5 precentile rarios
    sigRatio = prctile([ratios5_all_groups,ratios3_all_groups],5);
    save('sigRatio','sigRatio')

end


