function struct = aliFoldGroup(gr)

%% load and iniate
load(sprintf('gr%d_Zscore.mat',gr))
load(sprintf('gr%d_MSA.mat',gr))
load(sprintf('gr%d_energy_mat.mat',gr))
load('sigRatio.mat')
left_right = 100;

numGenes = size(MSA_ORF_nt,1);
numNtUTR3 = size(MSA_UTR3_nt{1},2);
numNtUTR5 = size(MSA_UTR5_nt{1},2);
numNtORF = size(MSA_ORF_nt{1},2);
numGetherd5 = size(MSA_gathered5{1},2);
numGetherd3 = size(MSA_gathered3{1},2);

% concatenate: 5UTR + ORF, ORF + 3UTR
combined_UTR5_ORF_MSA_num = zeros(numGenes,numNtUTR5+numNtORF);
combined_UTR3_ORF_MSA_num = zeros(numGenes,numNtUTR3+numNtORF);
for g = 1:numGenes
    combined_UTR5_ORF_MSA_num(g,:) = [MSA_UTR5_nt_num(g,:),MSA_ORF_nt_num(g,:)];
    combined_UTR3_ORF_MSA_num(g,:) = [MSA_ORF_nt_num(g,:),MSA_UTR3_nt_num(g,:)];
end
numZscore5 = size(MSA_Zscore5,2);
numZscore3 = size(MSA_Zscore3,2); 

%% 5UTR
% calculate the ratio between every position in Z score to it's surrounding
ratios5 = zeros(1,size(MSA_Zscore5,2));
mean_areas5 = zeros(1,size(MSA_Zscore5,2)-2*left_right);
for pos = left_right+1:size(MSA_Zscore5,2)-left_right
    mean_area = nanmean([MSA_Zscore5(pos-left_right:pos-1),MSA_Zscore5(pos+1:pos+left_right)]);
    mean_areas5(pos) = mean_area;
    ratios5(pos) = MSA_Zscore5(pos)-mean_area;
end

% find the positions with significant ratio and gather bulk of significant positions
signi5 = find(ratios5<sigRatio & not_indel_perc5'>=50);
signi5_groups = {};
curr_group = [];
new_group = 1;
if ~isempty(signi5)
    if size(signi5,2)==1
        signi5_groups = [signi5_groups,signi5];
    else
        for i = 2 : size(signi5,2)
            if new_group
                curr_group = [];
            end
            if signi5(i)==signi5(i-1)+1 || signi5(i)==signi5(i-1)+2
                if new_group
                   curr_group = [curr_group,signi5(i-1),signi5(i)];
                   new_group = 0;
                else
                curr_group = [curr_group,signi5(i)];
                new_group = 0;
                end
            else
               curr_group = signi5(i);
               new_group =1;
               signi5_groups = [signi5_groups;curr_group];
            end
            if i == size(signi5,1) 
                if new_group == 0
                    signi5_groups = [signi5_groups;curr_group];
                else
                    signi5_groups = [signi5_groups;signi5(end)];
                end
            end    
        end
    end
    signi5_startstop_ind = zeros(size(signi5_groups,1),2);
    for bulk = 1:size(signi5_groups,1)
        signi5_startstop_ind(bulk,:) = [signi5_groups{bulk}(1),signi5_groups{bulk}(end)];
    end

    expanded_ind5 = zeros(size(signi5_startstop_ind,1),2);  
    for bulk = 1:size(signi5_startstop_ind,1)
        right_ind = zeros(numGenes,1);
        left_ind = zeros(numGenes,1);
        for g = 1:numGenes
            right_seq = combined_UTR5_ORF_MSA_num(g,signi5_startstop_ind(bulk,2):end);
            right_not_indel = find(right_seq~=16) + signi5_startstop_ind(bulk,2) - 1;
            left_seq = combined_UTR5_ORF_MSA_num(g,1:signi5_startstop_ind(bulk,1));
            left_not_indel = find(left_seq~=16);
            if ~isempty(right_not_indel)
                if size(right_not_indel,2) >=39 %one window
                    right_ind(g) = right_not_indel(39);
                else
                    right_ind(g) = right_not_indel(end);
                end
            else
                right_ind(g) = signi5_startstop_ind(bulk,2);
            end
            if ~isempty(left_not_indel)
                if size(left_not_indel,2) >= 39
                    left_ind(g) = left_not_indel(end-39+1);
                else
                    left_ind(g) = left_not_indel(1);
                end
            else
                left_ind(g) = signi5_startstop_ind(bulk,1);
            end
        end
        max_right = ceil(prctile(right_ind,70));
        min_left = ceil(prctile(left_ind,30));
        expanded_ind5(bulk,1)=min_left;
        expanded_ind5(bulk,2)=max_right;
    end

    unique_startstop_signi5 = zeros(size(expanded_ind5,1),2); % it's the area to take that includes two windows left and right
    unique_signi5_startstop_ind = zeros(size(expanded_ind5,1),2);  % it's the significant inddices from the Zscore MSA
    new_group = 1;
    count = 0;
    if size(expanded_ind5,1) == 1
        unique_startstop_signi5(1,:) = [expanded_ind5(1,1),expanded_ind5(1,2)];
        unique_signi5_startstop_ind(1,:)  = [signi5_startstop_ind(1,1),signi5_startstop_ind(1,2)];
    else
        for i = 1:size(expanded_ind5,1)-1
            if ((expanded_ind5(i+1,1)-expanded_ind5(i,1)<39) + (expanded_ind5(i+1,2)-expanded_ind5(i,2)<39))>=1
                if new_group
                    start = i;
                    new_group = 0;
                end
            else
                count = count +1;
                if new_group
                    start = i;
                end
                stop = i;
                unique_startstop_signi5(count,:) = [expanded_ind5(start,1),expanded_ind5(stop,2)];
                unique_signi5_startstop_ind(count,:)  = [signi5_startstop_ind(start,1),signi5_startstop_ind(stop,2)];
                new_group = 1;
            end
        end
        count = count +1;
        if (expanded_ind5(i+1,1)-expanded_ind5(i,1)<39) + (expanded_ind5(i+1,2)-expanded_ind5(i,2)<39)>=1
            stop = i+1;
            unique_startstop_signi5(count,:) = [expanded_ind5(start,1),expanded_ind5(stop,2)];
            unique_signi5_startstop_ind(count,:)  = [signi5_startstop_ind(start,1),signi5_startstop_ind(stop,2)];
        else
            unique_startstop_signi5(count,:) = [expanded_ind5(start,1),expanded_ind5(i,2)];
            unique_signi5_startstop_ind(count,:)  = [signi5_startstop_ind(start,1),signi5_startstop_ind(i,2)];
            unique_startstop_signi5(count,:) = [expanded_ind5(i+1,1),expanded_ind5(i+1,2)];
            unique_signi5_startstop_ind(count,:)  = [signi5_startstop_ind(i+1,1),signi5_startstop_ind(i+1,2)];
        end
        unique_startstop_signi5 = unique_startstop_signi5(1:count,:);
        unique_signi5_startstop_ind = unique_signi5_startstop_ind(1:count,:);
    end
    
    % if the left ind is smaller than the right ind of the previous group
    % than expand it
    unique_startstop_signi5_add = zeros(size(unique_startstop_signi5,1),2); % cut it later
    unique_signi5_startstop_ind_add = zeros(size(unique_startstop_signi5,1),2);
    new_group = 1;
    count = 0;
    if size(unique_startstop_signi5,1)> 1
        for i = 1:size(unique_startstop_signi5,1)-1
            if unique_startstop_signi5(i+1,1)<unique_startstop_signi5(i,2)
                if new_group
                    start = i;
                    new_group = 0;
                end
            else
                count = count +1;
                if new_group
                    start = i;
                end
                stop = i;
                unique_startstop_signi5_add(count,:) = [unique_startstop_signi5(start,1),unique_startstop_signi5(stop,2)];
                unique_signi5_startstop_ind_add(count,:)  = [unique_startstop_signi5(start,1),unique_startstop_signi5(stop,2)];
                new_group = 1;
            end
        end
        count = count +1;
        if unique_startstop_signi5(i+1,1)<unique_startstop_signi5(i,2)
            stop = i+1;
            unique_startstop_signi5_add(count,:) = [unique_startstop_signi5(start,1),unique_startstop_signi5(stop,2)];
            unique_signi5_startstop_ind_add(count,:)  = [unique_startstop_signi5(start,1),unique_startstop_signi5(stop,2)];
        else
            unique_startstop_signi5_add(count,:) = [unique_startstop_signi5(start,1),unique_startstop_signi5(i,2)];
            unique_signi5_startstop_ind_add(count,:)  = [unique_startstop_signi5(start,1),unique_startstop_signi5(i,2)];
            unique_startstop_signi5_add(count,:) = [unique_startstop_signi5(i+1,1),unique_startstop_signi5(i+1,2)];
            unique_signi5_startstop_ind_add(count,:)  = [unique_startstop_signi5(i+1,1),unique_startstop_signi5(i+1,2)];
        end
        unique_startstop_signi5_add = unique_startstop_signi5_add(1:count,:);
        unique_signi5_startstop_ind_add = unique_signi5_startstop_ind_add(1:count,:);
    end
    
    % check for multiple of the same ind
    if ((size(unique_startstop_signi5_add,1)==1) + (unique_startstop_signi5_add(1,1)==0) + (unique_startstop_signi5_add(1,2)==0))==3
        unique_startstop_signi5_add = [];
    else
        multiple5 = [];
        for i = 1:size(unique_startstop_signi5,1)
            multiple = find(unique_startstop_signi5_add(:,1) == unique_startstop_signi5(i,1) & unique_startstop_signi5_add(:,2) == unique_startstop_signi5(i,2));
            multiple5 = [multiple5;multiple];
        end
        not_multiple_ind = setdiff([1:size(unique_startstop_signi5_add,1)],multiple5);
        unique_startstop_signi5_add = unique_startstop_signi5_add(not_multiple_ind,:);
        unique_signi5_startstop_ind_add = unique_signi5_startstop_ind_add(not_multiple_ind,:);
    end
    save(sprintf('gr%d_signi5_ind.mat',gr),'signi5_startstop_ind','expanded_ind5','unique_startstop_signi5','unique_signi5_startstop_ind','unique_startstop_signi5_add','unique_signi5_startstop_ind_add')    
        
    % take the alignments in the areas where there is a significant Zscore 5'
    MSA_forAliFold5 = cell(size(unique_startstop_signi5,1),1);
    for bulk = 1:size(unique_startstop_signi5,1)
        cur_MSA_forAliFold =cell(numGenes,1); 
        cur_seq_num = combined_UTR5_ORF_MSA_num(g,unique_startstop_signi5(bulk,1):unique_startstop_signi5(bulk,2));
        for g = 1:numGenes
            cur_MSA_forAliFold{g} = int2nt(cur_seq_num);
        end
        MSA_forAliFold5{bulk,1} = cur_MSA_forAliFold;
    end
    
    MSA_forAliFold5_add = cell(size(unique_startstop_signi5_add,1),1);
    for bulk = 1:size(unique_startstop_signi5_add,1)
        cur_MSA_forAliFold =cell(numGenes,1); 
        cur_seq_num = combined_UTR5_ORF_MSA_num(g,unique_startstop_signi5_add(bulk,1):unique_startstop_signi5_add(bulk,2));
        for g = 1:numGenes
            cur_MSA_forAliFold{g} = int2nt(cur_seq_num);
        end
        MSA_forAliFold5_add{bulk,1} = cur_MSA_forAliFold;
    end
    
    %% predict strcture with Alifold
    % create fasta 5'
    start_bulk5 = 0;
    for bulk = start_bulk5:size(unique_startstop_signi5,1)
        fastawrite(sprintf('gr%d_ali_%d_%d_%d_%d_5.fa',gr,unique_startstop_signi5(bulk,1), unique_startstop_signi5(bulk,2),unique_signi5_startstop_ind(bulk,1),unique_signi5_startstop_ind(bulk,2)),Names,MSA_forAliFold5{bulk})
        % send to alifold
        [info,struct]=system(sprintf('ViennaRNA-2.4.17/bin/RNAalifold -p -r -d2 --noLP --color --aln -f F < gr%d_ali_%d_%d_%d_%d_5.fa > gr%d_struct_%d_%d_%d_%d_5.txt',gr,unique_startstop_signi5(bulk,1), unique_startstop_signi5(bulk,2),unique_signi5_startstop_ind(bulk,1),unique_signi5_startstop_ind(bulk,2),gr,unique_startstop_signi5(bulk,1), unique_startstop_signi5(bulk,2),unique_signi5_startstop_ind(bulk,1),unique_signi5_startstop_ind(bulk,2)));
        save(sprintf('gr%d_struct_%d_%d_%d_%d_5',gr,unique_startstop_signi5(bulk,1), unique_startstop_signi5(bulk,2),unique_signi5_startstop_ind(bulk,1),unique_signi5_startstop_ind(bulk,2)),'struct');
        movefile('alirna.ps', sprintf('gr%d_struct_%d_%d_%d_%d_5.ps',gr,unique_startstop_signi5(bulk,1), unique_startstop_signi5(bulk,2),unique_signi5_startstop_ind(bulk,1),unique_signi5_startstop_ind(bulk,2)));
    end
        
    start_bulk5 = 0; 
    for bulk = start_bulk5:size(unique_startstop_signi5_add,1)
        fastawrite(sprintf('gr%d_ali_%d_%d_%d_%d_5.fa',gr,unique_startstop_signi5_add(bulk,1), unique_startstop_signi5_add(bulk,2),unique_signi5_startstop_ind_add(bulk,1),unique_signi5_startstop_ind_add(bulk,2)),Names,MSA_forAliFold5_add{bulk})
        % send to alifold
        [info,struct]=system(sprintf('ViennaRNA-2.4.17/bin/RNAalifold -p -r -d2 --noLP --color --aln -f F < gr%d_ali_%d_%d_%d_%d_5.fa > gr%d_struct_%d_%d_%d_%d_5.txt',gr,unique_startstop_signi5_add(bulk,1), unique_startstop_signi5_add(bulk,2),unique_signi5_startstop_ind_add(bulk,1),unique_signi5_startstop_ind_add(bulk,2),gr,unique_startstop_signi5_add(bulk,1), unique_startstop_signi5_add(bulk,2),unique_signi5_startstop_ind_add(bulk,1),unique_signi5_startstop_ind_add(bulk,2)));
        % RNAalifold -p -r -d2 --noLP --color --aln %% try this i took it from the result of the web server RNaalifold
        save(sprintf('gr%d_struct_%d_%d_%d_%d_5',gr,unique_startstop_signi5_add(bulk,1), unique_startstop_signi5_add(bulk,2),unique_signi5_startstop_ind_add(bulk,1),unique_signi5_startstop_ind_add(bulk,2)),'struct');
        movefile('alirna.ps', sprintf('gr%d_struct_%d_%d_%d_%d_5.ps',gr,unique_startstop_signi5_add(bulk,1), unique_startstop_signi5_add(bulk,2),unique_signi5_startstop_ind_add(bulk,1),unique_signi5_startstop_ind_add(bulk,2)));

    end
end

%% 3UTR
% calculate the ratio between every position in Z score to it's surrounding
ratios3 = zeros(1,size(MSA_Zscore3,2));
mean_areas3 = zeros(1,size(MSA_Zscore3,2)-2*left_right);
for pos = left_right+1:size(MSA_Zscore3,2)-left_right
    mean_area = nanmean([MSA_Zscore3(pos-left_right:pos-1),MSA_Zscore3(pos+1:pos+left_right)]);
    mean_areas3(pos) = mean_area;
    ratios3(pos) = MSA_Zscore3(pos)-mean_area;
end

% find the positions with significant ratio and gather bulk of significant positions
signi3 = find(ratios3<sigRatio & not_indel_perc3'>=50);
signi3_groups = {};
curr_group = [];
new_group = 1;
if ~isempty(signi3)
    if size(signi3,2)==1
        signi3_groups = [signi3_groups,signi3];
    else
        for i = 2 : size(signi3,2)
            if new_group
                curr_group = [];
            end
            if signi3(i)==signi3(i-1)+1 || signi3(i)==signi3(i-1)+2
                if new_group
                   curr_group = [curr_group,signi3(i-1),signi3(i)];
                   new_group = 0;
                else
                curr_group = [curr_group,signi3(i)];
                new_group = 0;
                end
            else
               curr_group = signi3(i);
               new_group =1;
               signi3_groups = [signi3_groups;curr_group];
            end
            if i == size(signi3,1) 
                if new_group == 0
                    signi3_groups = [signi3_groups;curr_group];
                else
                    signi3_groups = [signi3_groups;signi3(end)];
                end
            end    
        end
    end
    signi3_startstop_ind = zeros(size(signi3_groups,1),2);
    for bulk = 1:size(signi3_groups,1)
        signi3_startstop_ind(bulk,:) = [signi3_groups{bulk}(1),signi3_groups{bulk}(end)];
    end

    expanded_ind3 = zeros(size(signi3_startstop_ind,1),2);  
    for bulk = 1:size(signi3_startstop_ind,1)
        right_ind = zeros(numGenes,1);
        left_ind = zeros(numGenes,1);
        for g = 1:numGenes
            right_seq = combined_UTR3_ORF_MSA_num(g,signi3_startstop_ind(bulk,2):end);
            right_not_indel = find(right_seq~=16) + signi3_startstop_ind(bulk,2) - 1;
            left_seq = combined_UTR3_ORF_MSA_num(g,1:signi3_startstop_ind(bulk,1));
            left_not_indel = find(left_seq~=16);
            if ~isempty(right_not_indel)
                if size(right_not_indel,2) >=39 %one window
                    right_ind(g) = right_not_indel(39);
                else
                    right_ind(g) = right_not_indel(end);
                end
            else
                right_ind(g) = signi3_startstop_ind(bulk,2);
            end
            if ~isempty(left_not_indel)
                if size(left_not_indel,2) >= 39
                    left_ind(g) = left_not_indel(end-39+1);
                else
                    left_ind(g) = left_not_indel(1);
                end
            else
                left_ind(g) = signi3_startstop_ind(bulk,1);
            end
        end
        max_right = ceil(prctile(right_ind,70));
        min_left = ceil(prctile(left_ind,30));
        expanded_ind3(bulk,1)=min_left;
        expanded_ind3(bulk,2)=max_right;
    end

    unique_startstop_signi3 = zeros(size(expanded_ind3,1),2); % cut it later
    unique_signi3_startstop_ind = zeros(size(expanded_ind3,1),2);
    new_group = 1;
    count = 0;
    if size(expanded_ind3,1) == 1
        unique_startstop_signi3(1,:) = [expanded_ind3(1,1),expanded_ind3(1,2)];
        unique_signi3_startstop_ind(1,:)  = [signi3_startstop_ind(1,1),signi3_startstop_ind(1,2)];
    else
        for i = 1:size(expanded_ind3,1)-1
            if (expanded_ind3(i+1,1)-expanded_ind3(i,1)<39) + (expanded_ind3(i+1,2)-expanded_ind3(i,2)<39)>=1
                if new_group
                    start = i;
                    new_group = 0;
                end
            else
                count = count +1;
                if new_group
                    start = i;
                end
                stop = i;
                unique_startstop_signi3(count,:) = [expanded_ind3(start,1),expanded_ind3(stop,2)];
                unique_signi3_startstop_ind(count,:)  = [signi3_startstop_ind(start,1),signi3_startstop_ind(stop,2)];
                new_group = 1;
            end
        end
        count = count +1;
        if ((expanded_ind3(i+1,1)-expanded_ind3(i,1)<39) + (expanded_ind3(i+1,2)-expanded_ind3(i,2)<39))>=1
            stop = i+1;
            unique_startstop_signi3(count,:) = [expanded_ind3(start,1),expanded_ind3(stop,2)];
            unique_signi3_startstop_ind(count,:)  = [signi3_startstop_ind(start,1),signi3_startstop_ind(stop,2)];
        else
            unique_startstop_signi3(count,:) = [expanded_ind3(start,1),expanded_ind3(i,2)];
            unique_signi3_startstop_ind(count,:)  = [signi3_startstop_ind(start,1),signi3_startstop_ind(i,2)];
            unique_startstop_signi3(count,:) = [expanded_ind3(i+1,1),expanded_ind3(i+1,2)];
            unique_signi3_startstop_ind(count,:)  = [signi3_startstop_ind(i+1,1),signi3_startstop_ind(i+1,2)];
        end
        unique_startstop_signi3 = unique_startstop_signi3(1:count,:);
        unique_signi3_startstop_ind = unique_signi3_startstop_ind(1:count,:);
    end
    
    unique_startstop_signi3_add = zeros(size(unique_startstop_signi3,1),2); % cut it later
    unique_signi3_startstop_ind_add = zeros(size(unique_startstop_signi3,1),2);
    new_group = 1;
    count = 0;
    if size(unique_startstop_signi3,1)> 1
        for i = 1:size(unique_startstop_signi3,1)-1
            if unique_startstop_signi3(i+1,1)<unique_startstop_signi3(i,2)
                if new_group
                    start = i;
                    new_group = 0;
                end
            else
                count = count +1;
                if new_group
                    start = i;
                end
                stop = i;
                unique_startstop_signi3_add(count,:) = [unique_startstop_signi3(start,1),unique_startstop_signi3(stop,2)];
                unique_signi3_startstop_ind_add(count,:)  = [unique_startstop_signi3(start,1),unique_startstop_signi3(stop,2)];
                new_group = 1;
            end
        end
        count = count +1;
        if unique_startstop_signi3(i+1,1)<unique_startstop_signi3(i,2)
            stop = i+1;
            unique_startstop_signi3_add(count,:) = [unique_startstop_signi3(start,1),unique_startstop_signi3(stop,2)];
            unique_signi3_startstop_ind_add(count,:)  = [unique_startstop_signi3(start,1),unique_startstop_signi3(stop,2)];
        else
            unique_startstop_signi3_add(count,:) = [unique_startstop_signi3(start,1),unique_startstop_signi3(i,2)];
            unique_signi3_startstop_ind_add(count,:)  = [unique_startstop_signi3(start,1),unique_startstop_signi3(i,2)];
            unique_startstop_signi3_add(count,:) = [unique_startstop_signi3(i+1,1),unique_startstop_signi3(i+1,2)];
            unique_signi3_startstop_ind_add(count,:)  = [unique_startstop_signi3(i+1,1),unique_startstop_signi3(i+1,2)];
        end
        unique_startstop_signi3_add = unique_startstop_signi3_add(1:count,:);
        unique_signi3_startstop_ind_add = unique_signi3_startstop_ind_add(1:count,:);
    end
    if ((size(unique_startstop_signi3_add,1)==1) + (unique_startstop_signi3_add(1,1)==0) + (unique_startstop_signi3_add(1,2)==0))==3
        unique_startstop_signi3_add = [];
    else
            multiple3 = [];
        for i = 1:size(unique_startstop_signi3,1)
            multiple = find(unique_startstop_signi3_add(:,1) == unique_startstop_signi3(i,1) & unique_startstop_signi3_add(:,2) == unique_startstop_signi3(i,2));
            multiple3 = [multiple3;multiple];
        end
        not_multiple_ind = setdiff([1:size(unique_startstop_signi3_add,1)],multiple3);
        unique_startstop_signi3_add = unique_startstop_signi3_add(not_multiple_ind,:);
        unique_signi3_startstop_ind_add = unique_signi3_startstop_ind_add(not_multiple_ind,:);
    end
    save(sprintf('gr%d_signi3_ind.mat',gr),'signi3_startstop_ind','expanded_ind3','unique_startstop_signi3','unique_signi3_startstop_ind','unique_startstop_signi3_add','unique_signi3_startstop_ind_add')    
    
    % take the alignments in the areas where there is a significant Zscore 3'
    MSA_forAliFold3 = cell(size(unique_startstop_signi3,1),1);
    for bulk = 1:size(unique_startstop_signi3,1)
        cur_MSA_forAliFold =cell(numGenes,1); 
        cur_seq_num = combined_UTR3_ORF_MSA_num(g,unique_startstop_signi3(bulk,1):unique_startstop_signi3(bulk,2));
        for g = 1:numGenes
            cur_MSA_forAliFold{g} = int2nt(cur_seq_num);
        end
        MSA_forAliFold3{bulk,1} = cur_MSA_forAliFold;
    end
    
    MSA_forAliFold3_add = cell(size(unique_startstop_signi3_add,1),1);
    for bulk = 1:size(unique_startstop_signi3_add,1)
        cur_MSA_forAliFold =cell(numGenes,1); 
        cur_seq_num = combined_UTR3_ORF_MSA_num(g,unique_startstop_signi3_add(bulk,1):unique_startstop_signi3_add(bulk,2));
        for g = 1:numGenes
            cur_MSA_forAliFold{g} = int2nt(cur_seq_num);
        end
        MSA_forAliFold3_add{bulk,1} = cur_MSA_forAliFold;
    end

    %% predict strcture with Alifold
    % create fasta 3'
    start_bulk3 = 0; 
    for bulk = start_bulk3:size(unique_startstop_signi3,1)
        fastawrite(sprintf('gr%d_ali_%d_%d_%d_%d_3.fa',gr,unique_startstop_signi3(bulk,1), unique_startstop_signi3(bulk,2),unique_signi3_startstop_ind(bulk,1),unique_signi3_startstop_ind(bulk,2)),Names,MSA_forAliFold3{bulk})
        % send to alifold
        [~,struct]=system(sprintf('ViennaRNA-2.4.17/bin/RNAalifold -p -r -d2 --noLP --color --aln -f F < gr%d_ali_%d_%d_%d_%d_3.fa > gr%d_struct_%d_%d_%d_%d_3.txt',gr,unique_startstop_signi3(bulk,1), unique_startstop_signi3(bulk,2),unique_signi3_startstop_ind(bulk,1),unique_signi3_startstop_ind(bulk,2),gr,unique_startstop_signi3(bulk,1), unique_startstop_signi3(bulk,2),unique_signi3_startstop_ind(bulk,1),unique_signi3_startstop_ind(bulk,2)));
        % RNAalifold -p -r -d2 --noLP --color --aln %% try this i took it from the result of the web server RNaalifold
        save(sprintf('gr%d_struct_%d_%d_%d_%d_3',gr,unique_startstop_signi3(bulk,1), unique_startstop_signi3(bulk,2),unique_signi3_startstop_ind(bulk,1),unique_signi3_startstop_ind(bulk,2)),'struct');
        movefile('alirna.ps', sprintf('gr%d_struct_%d_%d_%d_%d_3.ps',gr,unique_startstop_signi3(bulk,1), unique_startstop_signi3(bulk,2),unique_signi3_startstop_ind(bulk,1),unique_signi3_startstop_ind(bulk,2)));
    end

    start_bulk3 = 0; 
    for bulk = start_bulk3:size(unique_startstop_signi3_add,1)
        fastawrite(sprintf('gr%d_ali_%d_%d_%d_%d_3.fa',gr,unique_startstop_signi3_add(bulk,1), unique_startstop_signi3_add(bulk,2),unique_signi3_startstop_ind_add(bulk,1),unique_signi3_startstop_ind_add(bulk,2)),Names,MSA_forAliFold3_add{bulk})
        % send to alifold
        [~,struct]=system(sprintf('ViennaRNA-2.4.17/bin/RNAalifold -p -r -d2 --noLP --color --aln -f F < gr%d_ali_%d_%d_%d_%d_3.fa > gr%d_struct_%d_%d_%d_%d_3.txt',gr,unique_startstop_signi3_add(bulk,1), unique_startstop_signi3_add(bulk,2),unique_signi3_startstop_ind_add(bulk,1),unique_signi3_startstop_ind_add(bulk,2),gr,unique_startstop_signi3_add(bulk,1), unique_startstop_signi3_add(bulk,2),unique_signi3_startstop_ind_add(bulk,1),unique_signi3_startstop_ind_add(bulk,2)));
        % RNAalifold -p -r -d2 --noLP --color --aln %% try this i took it from the result of the web server RNaalifold
        save(sprintf('gr%d_struct_%d_%d_%d_%d_3',gr,unique_startstop_signi3_add(bulk,1), unique_startstop_signi3_add(bulk,2),unique_signi3_startstop_ind_add(bulk,1),unique_signi3_startstop_ind_add(bulk,2)),'struct');
        movefile('alirna.ps', sprintf('gr%d_struct_%d_%d_%d_%d_3.ps',gr,unique_startstop_signi3_add(bulk,1), unique_startstop_signi3_add(bulk,2),unique_signi3_startstop_ind_add(bulk,1),unique_signi3_startstop_ind_add(bulk,2)));

    end
end

end
