function [fold_energy_mat] = mRNA_fold(genes,mRNA_l)
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Calculates the fold energy of all the genes mRNA, window length = mRNA_l,
% in all positions -50:-1
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% parameters 
am_genes=length(genes);
pos=50;
% sequence for text
[seq_fold] = create_fold_seq(genes,mRNA_l,pos);

% create text file
fid = fopen(sprintf('fold%d.txt',mRNA_l),'wt');
fprintf(fid,'%s\n',seq_fold{:});
fclose(fid);

% energy value
[~,output] = system(sprintf('./RNAfold -d2 < fold%d.txt',mRNA_l));
energy = (regexp(output,'-?\d+\.\d*','match'));

count_genes=0;
p=1;
fold_energy_mat=zeros(am_genes,pos);
for en=1:length(energy)
    if count_genes==am_genes
        p=p+1;
        count_genes=0;
    end
    count_genes=count_genes+1;    
    fold_energy_mat(count_genes,p)=str2num(energy{en});
end
end