function [ORF_Sequences,UTR3_Sequences,UTR5_Sequences,Names,l3_max,l5_max] = create_fasta(genome_table)
    l3_max = 0;
    l5_max = 0;
    lORF_max = 0;
    ORF_Sequences = cell(height(genome_table),1);
    UTR3_Sequences = cell(height(genome_table),1);
    UTR5_Sequences = cell(height(genome_table),1);
    Names = cell(height(genome_table),1);
    
    % finding the length of UTR to take
    lengths3 = zeros(height(genome_table),1);
    lengths5 = zeros(height(genome_table),1);
    lengths = zeros(height(genome_table),1);
    for gene = 1:height(genome_table)
        lengths3(gene) = length(genome_table.UTR3{gene});
        lengths5(gene) = length(genome_table.UTR5{gene});
        lengths(gene) = length(genome_table.ORF{gene});
    end
    l3_max = ceil(prctile(lengths3,20));
    l5_max = ceil(prctile(lengths5,20));    
    for g = 1:height(genome_table)
        ORF_Sequences{g} = genome_table.AA_ORF{g};
        UTR3 = genome_table.UTR3{g};
        UTR5 = genome_table.UTR5{g};
        if length(UTR3)>=l3_max
           UTR3_max = UTR3(1:l3_max);
        else
            UTR3_max = UTR3;
        end
        if length(UTR5)>=l5_max
           UTR5_max = UTR5(end-l5_max+1:end);
        else
            UTR5_max = UTR5;
        end
        UTR3_Sequences{g} = UTR3_max;
        UTR5_Sequences{g} = UTR5_max;
        Names{g}=sprintf('%d',g);
    end
end