load('number_chloro.mat')
genes_names={};
chloro_names = [];
for c = 1:number_chloro
    load(sprintf('chloro%d.mat',c))
    for gene = 1:height(chloro)
        gene_name = upper(chloro.genes_name{gene});
        gr=find(strcmp(genes_names,gene_name));
        if ~isempty(gr)
            group_num = gr;
        else
            genes_names = [genes_names;gene_name];
            group_num = size(genes_names,1)+1;
        end
        if exist(sprintf('raw_group%d.mat',group_num))
            load(sprintf('raw_group%d.mat',group_num))
        else
            group ={};
            save(sprintf('raw_group%d.mat',group_num),'group')
        end
        l=size(group,1);
        group{l+1,1}=c;
        group{l+1,2}=chloro.genomes_name{gene};
        chloro_names = [chloro_names;chloro.genomes_name{gene}];
        group{l+1,3}=gene;
        group{l+1,4}=chloro.genes_name{gene};
        group{l+1,5}=chloro.ORF{gene};
        group{l+1,6}=nt2aa(chloro.ORF{gene});
        group{l+1,7}=chloro.UTR5{gene};
        group{l+1,8}=chloro.UTR3{gene};
        group{l+1,9}=chloro.genes_energy{gene}; 
        group{l+1,10}=chloro.CAI{gene}; 
        group{l+1,10}=chloro.CAI_Zscore{gene};
        save(sprintf('raw_group%d.mat',group_num),'group')
    end
end
save('chloro_names','chloro_names')
exist_group = 1;
gr = 1;
count_groups = 0;
while exist_group
    if exist(sprintf('raw_group%d.mat',gr))
        load(sprintf('raw_group%d.mat',gr))
        group = cell2table(group, 'VariableNames', {'C','Chloro','g','Gene_name','ORF','AA_ORF','UTR5','UTR3','Genes_energy','CAI','CAI_Zscore'});
        % save only groups that has genes from more than 70% of the
        % chloroplasts:
        if height(group)>=0.7*number_chloro
            count_groups = count_groups + 1;
            save(sprintf('group%d.mat',count_groups),'group')
            % filter the genes in the group
            group = calculate_graph_by_blast_for_group(count_groups);
            save(sprintf('group%d',count_groups),'group')
        end
    else
        exist_group = 0;
    end    
end

number_groups = count_groups;
save('number_groups.mat','number_groups')
save('genes_names','genes_names')




